function JobFactoryOwnerSO::getSuccessMessage(%so)
{
	return "\c6Your ability to manage business is unsurpassed. You can now \c3Run a Factory\c6!";
}

function JobFactoryOwnerSO::onJobOp(%so, %client, %profile, %category, %opID, %parameters)
{
	%value = mAbs(mFloatLength(%parameters, 0));
	
	if(%parameters !$= %parameters)
		return -1;
	
	switch(%opID)
	{
		case 1:
			if(%parameters > %profile.plastic)
				%parameters = %profile.plastic;
			
			if(%parameters <= 0)
				return false;
			
			%price = mFloor(%parameters * SystemSO.pricePlastic);
			%taxes = mFloor(%price * (SystemSO.taxTarriff / 100));
			%profit = %price - %taxes;
			
			if(%price < 100)
			{
				%client.sendMessageBox("Does Not Compute", "You are not selling enough plastic to make $100 (Current: $" @ %price @ ")" NL
					"\nFor practical reasons, the transportation company will not ship your goods to the foreign city until you make at least $100.");
				return -1;
			}
			
			// Update
			%profile.plastic -= %parameters;
			%profile.bank += %profit;
			SystemSO.addToTreasury(%taxes);
			
			%client.massCashChange += %profit;
			cancel(%client.sendMassUpdateSched);
			%client.sendMassUpdateSched = %client.schedule(32, "sendMassUpdate");
			
			return "Sold \c5" @ %parameters @ "\c6 Raw Plastic to a foreign agent for \c2$" @ %price @ "\c6." NL
				"The City collected \c0$" @ %taxes @ "\c6 in taxes on Raw Plastic sales.";
			
		case 2:
			if(%parameters > %profile.refplastic)
				%parameters = %profile.refplastic;
			
			if(%parameters <= 0)
				return -1;
			
			%price = mFloor(%parameters * SystemSO.priceRPlastic);
			%taxes = mFloor(%price * (SystemSO.taxTarriff / 100));
			%profit = %price - %taxes;
			
			if(%price < 100)
			{
				%client.sendMessageBox("Does Not Compute", "You are not selling enough plastic to make $100 (Current: $" @ %price @ ")" NL
					"\nFor practical reasons, the transportation company will not ship your goods to the foreign city until you make at least $100.");
				return -1;
			}
				
			
			// Update
			%profile.refPlastic -= %parameters;
			%profile.bank += %profit;
			SystemSO.addToTreasury(%taxes);
			
			%client.massCashChange += %profit;
			cancel(%client.sendMassUpdateSched);
			%client.sendMassUpdateSched = %client.schedule(32, "sendMassUpdate");
			
			return "Sold \c5" @ %parameters @ "\c6 Refined Plastic to a foreign agent for \c2$" @ %price @ "\c6." NL
				"The City collected \c0$" @ %taxes @ "\c6 in taxes on Refined Plastic sales.";
	}
	
	return -1;
}

if(!isObject(JobFactoryOwnerSO))
{
	new ScriptObject(JobFactoryOwnerSO)
	{
		class			= "JobSO";
		name			= "Factory Owner";
		id				= "1" @ "04" @ "05";
		
		cleanRecord	= false;
		cost			= 20000;
		education	= 6;
		expMin		= 250;
		expTier		= 2;
		expTree		= "Store";
		paycheck		= 0;
		payday		= -1;
		police		= false;
		
		runFactory	= true;
		runMonopoly	= false;
		sellArms		= false;
		sellFood		= false;
		sellVehicle	= false;
		
		outfit		= "OutfitTuxedoSO";
		tools			= "";
		
		// Job Ops
		numOpCategories	= 1;
		
		numCategoryOps[0]	= 3;
		opCategory[0]		= "Exports";
		opName[0, 0]		= "About Exports";
		opRange[0, 0]		= "text Exporting your goods to foreign cities is fast money, but has heavy tariffs.";
		opName[0, 1]		= "Raw Plastic";
		opRange[0, 1]		= "int 0 [%STAT:Plastic] 0";
		opName[0, 2]		= "Refined Plastic";
		opRange[0, 2]		= "int 0 [%STAT:RefPlastic] 0";
	};
}