function JobMayorSO::isApplicable(%so, %client)
{
	return (SystemSO.mayorBLID == %client.bl_id);
}

function JobMayorSO::isAvailable(%so, %client)
{
	return (SystemSO.mayorBLID == %client.bl_id);
}

function JobMayorSO::isHeadProtected(%so)
{
	return true;
}

function JobMayorSO::getArmor(%so)
{
	return 0.50;
}

function JobMayorSO::getDataAddendum(%so, %profile, %client)
{
	%names = "taxCommercial";
	%values = SystemSO.taxCommercial;
	
	%names = %names TAB "taxLots";
	%values = %values TAB SystemSO.taxLots;
	
	%names = %names TAB "taxMonopoly";
	%values = %values TAB SystemSO.taxMonopoly;
	
	%names = %names TAB "taxPlastic";
	%values = %values TAB SystemSO.taxPlastic;
	
	%names = %names TAB "taxRefPlastic";
	%values = %values TAB SystemSO.taxRefPlastic;
	
	%names = %names TAB "taxTarriff";
	%values = %values TAB SystemSO.taxTarriff;
	
	%names = %names TAB "taxWeapon";
	%values = %values TAB SystemSO.taxWeapon;
	
	%names = %names TAB "treasury";
	%values = %values TAB SystemSO.treasury;
	
	%names = %names TAB "mayorPay";
	%values = %values TAB SystemSO.mayorPay;
	
	return %names NL %values;
}

function JobMayorSO::getError(%so, %client)
{
	return "You cannot apply for Mayor!" TAB "You cannot directly apply for this position because the Mayor is a public servant of CityRPG and is elected democratically.";
}

function JobMayorSO::onJobOp(%so, %client, %profile, %category, %opID, %parameters)
{
	%value = mAbs(mFloatLength(%parameters, 0));
	
	if(%value !$= %parameters)
		return -1;
	
	switch(%category)
	{
		// Taxes
		case 0:
			switch(%opID)
			{
				// Sales Tax
				case 2:
					%value = mClamp(%value, 0, 100);
					
					if(%value == SystemSO.taxCommercial)
						return -1;
					
					%oldValue = SystemSO.taxCommercial;
					SystemSO.taxCommercial = %value;
					%diff = (%oldValue > %value) ? "\c2decreased\c6" : "\c3increased\c6";
					
					return "\c6Sales Taxes were" SPC %diff SPC "\c6from \c3" @ %oldValue @ "%\c6 to \c3" @ %value @ "%\c6.";
					
				// Lot Tax
				case 3:
					%value = mClamp(%value, 0, 100);
					
					if(%value == SystemSO.taxLots)
						return -1;
					
					%oldValue = SystemSO.taxLots;
					SystemSO.taxLots = %value;
					%diff = (%oldValue > %value) ? "\c2decreased\c6" : "\c3increased\c6";
					
					return "\c6Lot Taxes were" SPC %diff SPC "from \c3" @ %oldValue @ "%\c6 to \c3" @ %value @ "%\c6.";
				
				// Monopoly Tax
				case 4:
					%value = mClamp(%value, 0, 100);
					
					if(%value == SystemSO.taxMonopoly)
						return -1;
					
					%oldValue = SystemSO.taxMonopoly;
					SystemSO.taxMonopoly = %value;
					%diff = (%oldValue > %value) ? "\c2decreased\c6" : "\c3increased\c6";
					
					return "\c6Big Business Taxes were" SPC %diff SPC "from \c3" @ %oldValue @ "%\c6 to \c3" @ %value @ "%\c6.";
				
				// Raw Plastic Tax
				case 5:
					%value = mClamp(%value, 0, 100);
					
					if(%value == SystemSO.taxPlastic)
						return -1;
					
					%oldValue = SystemSO.taxPlastic;
					SystemSO.taxPlastic = %value;
					%diff = (%oldValue > %value) ? "\c2decreased\c6" : "\c3increased\c6";
					
					return "\c6Raw Plastic Taxes were" SPC %diff SPC "from \c3" @ %oldValue @ "%\c6 to \c3" @ %value @ "%\c6.";
				
				// Ref Plastic Tax
				case 6:
					%value = mClamp(%value, 0, 100);
					
					if(%value == SystemSO.taxRefPlastic)
						return -1;
					
					%oldValue = SystemSO.taxRefPlastic;
					SystemSO.taxRefPlastic = %value;
					%diff = (%oldValue > %value) ? "\c2decreased\c6" : "\c3increased\c6";
					
					return "\c6Refined Plastic Taxes were" SPC %diff SPC "from \c3" @ %oldValue @ "%\c6 to \c3" @ %value @ "%\c6.";
				
				// Tariffs Tax
				case 7:
					%value = mClamp(%value, 0, 100);
					
					if(%value == SystemSO.taxTarriff)
						return -1;
					
					%oldValue = SystemSO.taxTarriff;
					SystemSO.taxTarriff = %value;
					%diff = (%oldValue > %value) ? "\c2decreased\c6" : "\c3increased\c6";
					
					return "\c6Export Tariffs were" SPC %diff SPC "from \c3" @ %oldValue @ "%\c6 to \c3" @ %value @ "%\c6.";
					
				
				// Weapon Tax
				case 8:
					%value = mClamp(%value, 0, 100);
					
					if(%value == SystemSO.taxWeapon)
						return -1;
					
					%oldValue = SystemSO.taxWeapon;
					SystemSO.taxWeapon = %value;
					%diff = (%oldValue > %value) ? "\c2decreased\c6" : "\c3increased\c6";
					
					return "\c6Weapon Taxes were" SPC %diff SPC "from \c3" @ %oldValue @ "%\c6 to \c3" @ %value @ "%\c6.";
				
			}
		
		// Morals
		case 1:
			switch(%opID)
			{
				// Abortion
				case 1:
					%value = mClamp(%value, 0, 1);
					
					if(%value == SystemSO.moralAbortion)
						return -1;
					
					%oldValue = SystemSO.moralAbortion;
					SystemSO.moralAbortion = %value;
					%diff = %value ? "\c2legalized" : "\c3illegalized";
					
					return "\c6Abortions have been" SPC %diff @ "\c6.";
				
				// Felon Weapons
				case 2:
					%value = mClamp(%value, 0, 1);
					
					if(%value == SystemSO.moralFelonGun)
						return -1;
					
					%oldValue = SystemSO.moralFelonGun;
					SystemSO.moralFelonGun = %value;
					%diff = %value ? "\c2legalized" : "\c3illegalized";
					
					return "\c6Selling weapons to convicted felons has been" SPC %diff @ "\c6.";
					
			}
		
		// Wages
		case 2:
			switch(%opID)
			{
				// 
				case 1:
					%value = mClamp(%value, 0, 500);
					
					if(%value == SystemSO.mayorPay)
						return -1;
					
					%oldValue = SystemSO.mayorPay;
					SystemSO.mayorPay = %value;
					%diff = %value > %oldValue ? "\c3increased" : "\c3decreased";
					
					return "\c6The mayor's wages have been" SPC %diff @ "\c6 to \c3" @ %value @ "\c6.";
			}
	}
	
	return -1;
}

function JobMayorSO::onJobOpEnd(%so, %client, %profile, %success)
{
	if(getLineCount(%success) <= 0)
		return;
	
	messageAll('MsgAdminForce', "\c4Attention! \c3Mayor " @ %client.name @ "\c6 has enacted changes on City Law!");
	
	for(%a = 0; %a < getLineCount(%success); %a++)
	{
		%line = getLine(%success, %a);
		
		if(%line !$= "")
			messageAll('', "\c3 +- " @ %line);
	}
}

function JobMayorSO::onKilled(%so, %client, %profile, %sourceClient, %sourceProfile, %sourceObject, %transform, %damageType)
{
	if(!%profile.getWantedLevel())
	{
		if(JobBureaucratSO.isAvailable(%client))
			JobBureaucratSO.setJobFor(%client, false);
		else
			JobUnemployedSO.setJobFor(%client, false);
		
		messageAll('', "The Mayor has been Assassinated.");
		
		%sourceClient.commitCrime("Murder of a Political Figure", 250, false, true, false, true, CalendarSO.getDaysInSeconds(30) * 1000, %transform);
	}
	
	%client.sendData();
}

function JobMayorSO::onTick(%so, %client)
{
	%profile = %client.profile;
	
	if(isObject(%profile))
	{
		%profile.workhours += CalendarSO.length;
		
		if(mFloor(CalendarSO.time / 24) > mFloor((CalendarSO.time - CalendarSO.length) / 24))
		{
			%pay = SystemSO.mayorPay * 7;
			%pay *= %profile.workhours / 168;
			%pay = mClamp(%pay, 0, SystemSO.getTreasuryTrickle());
			//%pay = SystemSO.deductFromTreasury(%pay);
			
			if(%pay > 0)
			{
				%profile.exp[%so.expTree]++;
				
				%profile.workhours = 0;
				%interest = mClamp(mFloor(%profile.debt * 0.1), 0, mFloor(%pay / 2));
				
				messageAllExcept(%client, '', '\c6 - \c3Mayor %2\c6 recieved a \c3$%1\c6 paycheck.', %pay, %client.name);
				
				if(%interest > 0)
				{
					%final -= %interest;
					
					messageClient(%client, '', '\c6 - You recieved a \c3$%1\c6 paycheck, but \c0$%2\c6 was automatically taken out due to your debt\'s interest.', %pay, %interest);
					%profile.bank += %final;
				}
				else
				{
					messageClient(%client, '', '\c6 - You recieved a \c3$%1\c6 paycheck.', %pay);
					%profile.bank += %pay;
				}
			}
		}
	}
}

if(!isObject(JobMayorSO))
{
	new ScriptObject(JobMayorSO)
	{
		class			= "JobSO";
		name			= "Mayor";
		id				= "1" @ "06" @ "02";
		
		cleanRecord	= true;
		cost			= 0;
		doNoEvil		= true;
		education	= 0;
		expMin		= 0;
		expTier		= 3;
		expTree		= "PC";
		unlisted		= true;
		paycheck		= 0; // SystemSO.mayorPay
		payday		= 4;
		police		= false;
		
		outfit		= "OutfitMayorSO";
		tools			= "CRPG_Hat_Mayor_Item";
		
		// Job Ops
		numOpCategories	= 4;
		
		// Taxes
		numCategoryOps[0]	= 9;
		opCategory[0]		= "Taxes";
		opName[0, 0]		= "About Taxes";
		opRange[0, 0]		= "text Taxes determine how much money the city earns each tick.";
		opName[0, 1]		= " ";
		opRange[0, 1]		= "text Note that taxes raise the cost of goods and voters will not like the higher prices!";
		
		opName[0, 2]		= "Sales Tax";
		opRange[0, 2]		= "int 0 100 [%STAT:taxCommercial]";
		opName[0, 3]		= "Property Tax";
		opRange[0, 3]		= "int 0 100 [%STAT:taxLots]";
		opName[0, 4]		= "Business Tax";
		opRange[0, 4]		= "int 0 100 [%STAT:taxMonopoly]";
		opName[0, 5]		= "Raw Plastic Tax";
		opRange[0, 5]		= "int 0 100 [%STAT:taxPlastic]";
		opName[0, 6]		= "Ref. Plastic Tax";
		opRange[0, 6]		= "int 0 100 [%STAT:taxRefPlastic]";
		opName[0, 7]		= "Tariffs";
		opRange[0, 7]		= "int 0 100 [%STAT:taxTariff]";
		opName[0, 8]		= "Weapons Tax";
		opRange[0, 8]		= "int 0 100 [%STAT:taxWeapon]";
		
		
		// Morals
		numCategoryOps[1]	= 3;
		opCategory[1]		= "Moral Issues";
		opName[1, 0]		= "About Morals";
		opRange[1, 0]		= "text Moral Laws lift or add restrictions to citizens. You can change them at a whim.";
		
		opName[1, 1]		= "Legal Abortions";
		opRange[1, 1]		= "bool [%STAT:moralAbortion]";
		opName[1, 2]		= "Felons Buy Guns";
		opRange[1, 2]		= "bool [%STAT:moralFelonGun]";
		
		// Wages
		numCategoryOps[2]	= 1;
		opCategory[2]		= "Wages";
		opName[2, 0]		= "Mayor's Wage";
		opRange[2, 0]		= "int 0 500 [%STAT:mayorIncome]";
		
		// Embezzlement
		numCategoryOps[3]	= 5;
		opCategory[3]		= "Embezzlement";
		opName[3, 0]		= "About Theft";
		opRange[3, 0]		= "text The City is entrusted in your care, but can you actually be trusted?";
		opName[3, 1]		= " ";
		opRange[3, 1]		= "text Tax Money is at your disposal to help the citizens... or yourself.";
		opName[3, 2]		= " ";
		opRange[3, 2]		= "text Stealing from the Government is a serious crime and can cause Anarchy!";
		
		opName[3, 3]		= "Embezzle";
		opRange[3, 3]		= "text Current Treasury: $[%STAT:treasury]";
		opName[3, 4]		= " ";
		opRange[3, 4]		= "int [%STAT:treasury] 100 0";
	};
}

if(!isObject(OutfitMayorSO))
{
	new ScriptObject(OutfitMayorSO)
	{
		class = "OutfitSO";
		
		decal = "Mod-Suit";
		outfit = 8;
		
		node[0] = "gender";
		node[1] = "genderlarm";
		node[2] = "genderrarm";
		node[3] = "LHand";
		node[4] = "RHand";
		node[5] = "pants";
		node[6] = "LShoe";
		node[7] = "RShoe";
		node[8] = "copHat";
		
		color[0] = "0.05 0.05 0.05 1.00";
		color[1] = "0.05 0.05 0.05 1.00";
		color[2] = "0.05 0.05 0.05 1.00";
		color[3] = "skin";
		color[4] = "skin";
		color[5] = "0.05 0.05 0.05 1.00";
		color[6] = "0.05 0.05 0.05 1.00";
		color[7] = "0.05 0.05 0.05 1.00";
		color[8] = "0.05 0.05 0.05 1.00";
	};
}