function JobSWATSO::getArmor(%so)
{
	return 0.25;
}

function JobSWATSO::getSuccessMessage(%so, %profile)
{
	%arrests = %profile.exp["Law"];
	%kd = mFloor((%profile.kills / %profile.deaths) * 100);
	%kd = mFloor(((%profile.kills + %arrests) / %profile.deaths) * 100);
	return "\c6You have become a \c3SWAT Officer\c6 with \c3" @ %arrests @ "\c6 arrests, \c3" @ %kd @ "% K/D Ratio, and \c5" @ %prestige @ "\c6 prestige.";
}

function JobSWATSO::isApplicable(%so, %client)
{
	%result = parent::isApplicable(%so, %client);
	
	if(%result)
	{
		if(%client.profile.kills < 50)
			return false;
		
		%kd = mFloor(((%client.profile.kills + %client.profile.exp["Law"]) / %client.profile.deaths) * 100);
		
		if(%kd < 100)
			return false;
	}
	
	return %result;
}

function JobSWATSO::getError(%so, %client)
{
	if(!isObject(%profile = %client.profile))
		return "No Profile" TAB "You have no profile!";
	
	if(%profile.job == %so.id)
		return "Same Job" TAB "You are applying for the same job you already are!";
	
	if(%profile.felon && %so.cleanRecord)
		return "You're a Felon!" TAB "As a convicted felon, you cannot apply for this job.";
	
	if(%profile.education < mFloor(%so.education))
		return "Not Enough Education" TAB "Your level of education is below what is required for this job.";
	
	if(%profile.exp[%so.expTree] < %so.expMin)
		return "Not Enough Experience" TAB "You cannot be a SWAT Officer until you first have made " @ %so.expMin @ " arrests.";
	
	if((%profile.money + %profile.bank) < mFloor(%so.cost))
		return "Insufficient Funds" TAB "You cant afford the investment!";
	
	if(%client.profile.kills < 50)
		return "No Bloodlust!" TAB "You cannot be a SWAT Officer without first getting your hands dirty." NL
			"The SWAT Department requires you to have at least 50 kills to your name." NL
			"Right now, you have" SPC %client.profile.kills @ ".";
	
	%kd = mFloor(((%client.profile.kills + %client.profile.exp["Law"]) / %client.profile.deaths) * 100);
	
	if(%kd < 100)
		return "No Prestige!" TAB "You have the experience and the body count to become SWAT." NL
			"However, your prestige level is only" SPC %kd @ "!\n" NL
			"Increase Prestige by not dying and making more arrests/kills per life.";
	
	return -1;
}

function JobSWATSO::onKilled(%so, %client, %profile, %sourceClient, %sourceProfile, %sourceObject, %transform, %damageType)
{
	if(!%profile.getWantedLevel())
	{
		%sourceClient.commitCrime("Murdering an Officer", 250, false, true, true, 240000, %transform);
	}
}

function JobSWATSO::onTick(%so, %client)
{
	%profile = %client.profile;
	
	if(isObject(%profile))
	{
		%profile.workhours += CalendarSO.length;
		
		if(mFloor(CalendarSO.time / 24) > mFloor((CalendarSO.time - CalendarSO.length) / 24))
		{
			%pay = %so.paycheck;
			%pay *= %profile.workhours / 168;
			%pay = mFloor(%pay);
			
			if(%pay > 100)
			{
				%profile.exp[%so.expTree]++;
				
				%profile.workhours = 0;
				%interest = mClamp(mFloor(%profile.debt * 0.1), 0, mFloor(%pay / 2));
				
				if(%interest > 0)
				{
					%final -= %interest;
					
					messageClient(%client, '', '\c6 - You recieved a \c3$%1\c6 paycheck, but \c0$%2\c6 was automatically taken out due to your debt\'s interest.', %pay, %interest);
					%profile.bank += %final;
				}
				else
				{
					messageClient(%client, '', '\c6 - You recieved a \c3$%1\c6 paycheck.', %pay);
					%profile.bank += %pay;
				}
			}
		}
	}
}

if(!isObject(JobSWATSO))
{
	new ScriptObject(JobSWATSO)
	{
		class			= "JobSO";
		name			= "SWAT Officer";
		id				= "1" @ "05" @ "02";
		
		cleanRecord	= true;
		cost			= 10000;
		education	= 4;
		expMin		= 50;
		expTier		= 1;
		expTree		= "Law";
		paycheck		= 1500;
		payday		= 4;
		police		= true;
		
		outfit		= "OutfitSWATSO";
		tools			= "CRPG_GasMask_Item" TAB "CRPG_Baton_Item" TAB "CRPG_HandcuffsU_Item" TAB "CRPG_Magnify_Item" TAB "CRPG_Assault_Item";
	};
}

if(!isObject(OutfitSWATSO))
{
	new ScriptObject(OutfitSWATSO)
	{
		class = "OutfitSO";
		
		decal = "Mod-Police";
		outfit = 10;
		headUp = true;
		
		node[0] = "gender";
		node[1] = "genderlarm";
		node[2] = "genderrarm";
		node[3] = "LHand";
		node[4] = "RHand";
		node[5] = "pants";
		node[6] = "LShoe";
		node[7] = "RShoe";
		node[8] = "armor";
		node[9] = "ShoulderPads";
		
		color[0] = "0.00 0.14 0.33 1.00";
		color[1] = "0.00 0.14 0.33 1.00";
		color[2] = "0.00 0.14 0.33 1.00";
		color[3] = "0.20 0.20 0.20 1.00";
		color[4] = "0.20 0.20 0.20 1.00";
		color[5] = "0.20 0.20 0.20 1.00";
		color[6] = "0.20 0.20 0.20 1.00";
		color[7] = "0.20 0.20 0.20 1.00";
		color[8] = "0.00 0.14 0.33 1.00";
		color[9] = "0.20 0.20 0.20 1.00";
	};
}
