function JobVagabondSO::onActivate(%so, %client, %obj)
{
	%profile = %client.getProfile();
	
	if(isObject(%profile))
	{
		// Start
		%start = %obj.getEyePoint();
		
		// End
		%aimVec = %obj.getAimVector();
		%range = 3 * getWord(%obj.getScale(), 2);
		%end = vectorAdd(%start, vectorScale(%aimVec, %range));
		
		// Masks
		%masks = ($TypeMasks::FxBrickObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType);
		
		%col = getWord(containerRayCast(%start, %end, %masks, %obj), 0);
		
		if(isObject(%col) && %col.getType() & $TypeMasks::PlayerObjectType)
		{
			%tclient = %col.client;
			
			if(isObject(%client))
			{
				%tprofile = %tclient.getProfile();
				
				if(isObject(%tprofile))
				{
					if($sim::time - %obj.lastBeg > 10 && $sim::time - %tclient.lastBeggedFrom[%obj.getID()] > 60)
					{
						%bill = %tprofile.getRandomBill();
						
						if(%bill > 0)
						{
							messageClient(%tclient, '', '\c6You felt really bad for \c3%1\c6, so you gave them \c3$%2\c6.', %client.name, %bill);
							messageClient(%client, '', '\c2Success! \c3%1\c6 felt really bad for you, so they gave you \c3$%2\c6.', %tclient.name, %bill);
							
							%tprofile.money -= %bill;
							%profile.money += %bill;
							
							%obj.lastBeg = $sim::time;
							%tclient.lastBeggedFrom[%obj.getID()] = $sim::time;
						}
						else
						{
							messageClient(%client, '', '\c3%1\c6 had no money.', %tclient.name);
						}
					}
				}
			}
		}
	}
}

function JobVagabondSO::isApplicable(%so, %client)
{
	%result = parent::isApplicable(%so, %client);
	
	if(%result)
		if(%client.profile.exp[%so.expTree] < 10)
			return false;
	
	return %result;
}

function JobVagabondSO::isAvailable(%so, %client)
{
	%result = parent::isAvailable(%so, %client);
	
	if(%result)
		if(%client.profile.exp[%so.expTree] < 10)
			return false;
	
	return %result;
}

function JobVagabondSO::getError(%so, %client)
{
	%result = parent::getError(%so, %client);
	
	if(%result == -1)
		if(%client.profile.exp[%so.expTree] < 10)
			return "Have some Dignity" TAB "Nobody really wants to be a Vagabond, not even you.\n\nStooping to the level of beggar would be a last-ditch effort.";
	
	return %result;
}

function JobVagabondSO::getSuccessMessage(%so, %profile)
{
	return "\c6You are now \c3a bum\c6.";
}

if(!isObject(JobVagabondSO))
{
	new ScriptObject(JobVagabondSO)
	{
		class			= "JobSO";
		name			= "Vagabond";
		id				= "1" @ "01" @ "02";
		
		cleanRecord	= false;
		cost			= 0;
		education	= 0;
		expMin		= 10;
		expTier		= 1;
		expTree		= "Bum";
		paycheck		= 0;
		payday		= -1;
		police		= false;
		
		outfit		= "OutfitVagabondSO";
		tools			= "";
	};
}

if(!isObject(OutfitVagabondSO))
{
	new ScriptObject(OutfitVagabondSO)
	{
		class = "OutfitSO";
		
		decal = "Hoodie";
		outfit = 8;
		
		node[0] = "gender";
		node[1] = "genderlarm";
		node[2] = "LHand";
		node[3] = "genderrarm";
		node[4] = "RHand";
		node[5] = "pants";
		node[6] = "LShoe";
		node[7] = "RShoe";
		
		color[0] = "0.39 0.20 0.00 1.00";
		color[1] = "skin";
		color[2] = "skin";
		color[3] = "0.39 0.20 0.00 1.00";
		color[4] = "0.20 0.20 0.20 1.00";
		color[5] = "0.20 0.20 0.20 1.00";
		color[6] = "0.39 0.20 0.00 1.00";
		color[7] = "skin";
		
		outfitMale		= 2;
		nodeMale[0]		= "knitHat";
		colorMale[0]	= "0.39 0.20 0.00 1.00";
		nodeMale[1]		= "plume";
		colorMale[1]	= "1.00 1.00 1.00 1.00";
		
		outfitFem		= 1;
		nodeFem[0]		= "knitHat";
		colorFem[0]		= "0.91 0.50 0.59 1.00";
	};
}
