// ============================================================
// File Name		:	Objects
// Description		:	The instantination of important datablocks.
// ============================================================
// Table of Contents
// 
// 1. Audio
// 2. Minigame
// 3. Bricks
// 4. Emitters
// 5. Shapes
// 6. Pick-Ups
// 7. Players
// ============================================================

if(!$CRPG_Temp::WeaponsMade)
{
	AddDamageType("Invisible", '', '', 1, 1);
	eval("AddDamageType(\"CRPGBaton\", '<bitmap:" @ $CRPG::Path::Images @ "CI/CI_Baton> %1', '%2 <bitmap:" @ $CRPG::Path::Images @ "CI/CI_Baton> %1', 0.25, 1);");
	eval("AddDamageType(\"CRPGAxe\", '<bitmap:" @ $CRPG::Path::Images @ "CI/CI_Axe> %1', '%2 <bitmap:" @ $CRPG::Path::Images @ "CI/CI_Axe> %1', 0.75, 1);");
	eval("AddDamageType(\"CRPGPickaxe\", '<bitmap:" @ $CRPG::Path::Images @ "CI/CI_Pickaxe> %1', '%2 <bitmap:" @ $CRPG::Path::Images @ "CI/CI_Pickaxe> %1', 1.00, 1);");
}

// ============================================================
// Section 1 : Audio
// ============================================================
if(!isObject(CRPG_Blunt_Hit_Sound))
{
	datablock AudioProfile(CRPG_Blunt_Hit_Sound)
	{
		filename		= $CRPG::Path::Sounds @ "blunt_hit.wav";
		description	= AudioClosest3d;
		preload		= true;
	};
}

if(!isObject(CRPG_Generic_Empty_Sound))
{
	datablock AudioProfile(CRPG_Generic_Empty_Sound)
	{
		filename		= $CRPG::Path::Sounds @ "generic_empty.wav";
		description	= AudioClose3d;
		preload		= true;
	};
}

if(!isObject(CRPG_Generic_Hit_Sound))
{
	datablock AudioProfile(CRPG_Generic_Hit_Sound)
	{
		filename		= $CRPG::Path::Sounds @ "generic_hit.wav";
		description	= AudioClose3d;
		preload		= true;
	};
}

if(!isObject(CRPG_Handcuff_Sound))
{
	datablock AudioProfile(CRPG_Handcuff_Sound)
	{
		filename		= $CRPG::Path::Sounds @ "handcuff_sound.wav";
		description	= AudioClosest3d;
		preload		= true;
	};
}

if(!isObject(CRPG_Metal_Hit_Sound))
{
	datablock AudioProfile(CRPG_Metal_Hit_Sound)
	{
		filename		= $CRPG::Path::Sounds @ "metal_hit.wav";
		description	= AudioClosest3d;
		preload		= true;
	};
}

if(!isObject(CRPG_Mission_Complete_Sound))
{
	datablock AudioProfile(CRPG_Mission_Complete_Sound)
	{
		filename		= $CRPG::Path::Sounds @ "mission_complete.wav";
		description	= AudioClosest3d;
		preload		= true;
	};
}

if(!isObject(CRPG_Hail_Chief_Sound))
{
	datablock AudioProfile(CRPG_Hail_Chief_Sound)
	{
		filename		= $CRPG::Path::Sounds @ "hail_to_the_chief.wav";
		description	= AudioClosest3d;
		preload		= true;
	};
}

if(!isObject(CRPG_Resource_Depleat_Sound))
{
	datablock AudioProfile(CRPG_Resource_Depleat_Sound)
	{
		filename		= $CRPG::Path::Sounds @ "resource_depleat.wav";
		description	= AudioClosest3d;
		preload		= true;
	};
}

if(!isObject(CRPG_Search_Sound))
{
	datablock AudioProfile(CRPG_Search_Sound)
	{
		filename		= $CRPG::Path::Sounds @ "magnify_sound.wav";
		description	= AudioClosest3d;
		preload		= true;
	};
}

if(!isObject(CRPG_Wood_Hit_Sound))
{
	datablock AudioProfile(CRPG_Wood_Hit_Sound)
	{
		filename		= $CRPG::Path::Sounds @ "wood_hit.wav";
		description	= AudioClosest3d;
		preload		= true;
	};
}

// ============================================================
// Section 2 : ScriptObjects
// ============================================================
if(!isObject(CRPGMinigame))
{
	CRPG_CreateMinigame();
}

// ============================================================
// Section 3 : Bricks
// ============================================================
if(!isObject(LotSS))
{
	new SimSet(LotSS);
}

// Cameras
if(!isObject(CRPG_Camera_Brick))
{
	datablock fxDTSBrickData(CRPG_Camera_Brick)
	{
		category		= "CityRPG";
		subCategory = "Property";
		
		brickFile	= $CRPG::Path::Bricks @ "1x3x4 Camera.blb";
		iconName		= $CRPG::Path::Images @ "brickIcons/Icon_Camera";
		uiName		= "Straight Camera";
		
		crpgCamera	= true;
		price			= 500;
	};
}

if(!isObject(CRPG_Camera_Angled_Brick))
{
	datablock fxDTSBrickData(CRPG_Camera_Angled_Brick)
	{
		category		= "CityRPG";
		subCategory = "Property";
		
		brickFile	= $CRPG::Path::Bricks @ "3x3x4 Camera.blb";
		iconName		= $CRPG::Path::Images @ "brickIcons/Icon_Camera_Angled";
		uiName		= "Angled Camera";
		
		crpgCamera	= true;
		price			= 500;
	};
}

// Lots
if(!isObject(CRPG_16x16_Lot_Brick))
{
	datablock fxDTSBrickData(CRPG_16x16_Lot_Brick : brick16x16fdata)
	{
		category = "CityRPG";
		subCategory = "Lots";
		uiName = "16x16 Lot";
		iconName = $CRPG::Path::Images @ "brickIcons/Icon_16x16_Lot";
		
		price = 1500;
		crpgLot = true;
		triggerDatablock = "CRPG_Lot_Trigger";
		triggerSize = "16 16" SPC $CRPG::TriggerSize;
	};
	
	LotSS.add(CRPG_16x16_Lot_Brick);
}

if(!isObject(CRPG_16x32_Lot_Brick))
{
	datablock fxDTSBrickData(CRPG_16x32_Lot_Brick : brick16x32fdata)
	{
		category = "CityRPG";
		subCategory = "Lots";
		uiName = "16x32 Lot";
		iconName = $CRPG::Path::Images @ "brickIcons/Icon_16x32_Lot";
		
		price = 3000;
		crpgLot = true;
		triggerDatablock = "CRPG_Lot_Trigger";
		triggerSize = "16 32" SPC $CRPG::TriggerSize;
	};
	
	LotSS.add(CRPG_16x32_Lot_Brick);
}

if(!isObject(CRPG_32x32_Lot_Brick))
{
	datablock fxDTSBrickData(CRPG_32x32_Lot_Brick : brick32x32fdata)
	{
		category = "CityRPG";
		subCategory = "Lots";
		uiName = "32x32 Lot";
		iconName = $CRPG::Path::Images @ "brickIcons/Icon_32x32_Lot";
		
		price = 6000;
		crpgLot = true;
		triggerDatablock = "CRPG_Lot_Trigger";
		triggerSize = "32 32" SPC $CRPG::TriggerSize;
	};
	
	LotSS.add(CRPG_32x32_Lot_Brick);
}

if(!isObject(CRPG_64x64_Lot_Brick))
{
	datablock fxDTSBrickData(CRPG_64x64_Lot_Brick : brick64x64fdata)
	{
		category = "CityRPG";
		subCategory = "Lots";
		uiName = "64x64 Lot";
		iconName = $CRPG::Path::Images @ "brickIcons/Icon_64x64_Lot";
		
		price = 12000;
		crpgLot = true;
		triggerDatablock = "CRPG_Lot_Trigger";
		triggerSize = "64 64" SPC $CRPG::TriggerSize;
	};
	
	LotSS.add(CRPG_64x64_Lot_Brick);
}

// Monopoly
if(!isObject(CRPG_16x16_Monopoly_Brick))
{
	datablock fxDTSBrickData(CRPG_16x16_Monopoly_Brick : brick16x16fdata)
	{
		category = "CityRPG";
		subCategory = "Monopoly Lots";
		uiName = "16x16 Business";
		iconName = $CRPG::Path::Images @ "brickIcons/Icon_16x16_Monopoly";
		
		price = 10000;
		crpgLot = true;
		triggerDatablock = "CRPG_Monopoly_Trigger";
		triggerSize = "16 16" SPC $CRPG::TriggerSize;
	};
	
	LotSS.add(CRPG_16x16_Monopoly_Brick);
}

if(!isObject(CRPG_16x32_Monopoly_Brick))
{
	datablock fxDTSBrickData(CRPG_16x32_Monopoly_Brick : brick16x32fdata)
	{
		category = "CityRPG";
		subCategory = "Monopoly Lots";
		uiName = "16x32 Business";
		iconName = $CRPG::Path::Images @ "brickIcons/Icon_16x32_Monopoly";
		
		price = 20000;
		crpgLot = true;
		triggerDatablock = "CRPG_Monopoly_Trigger";
		triggerSize = "16 32" SPC $CRPG::TriggerSize;
	};
	
	LotSS.add(CRPG_16x32_Monopoly_Brick);
}

if(!isObject(CRPG_32x32_Monopoly_Brick))
{
	datablock fxDTSBrickData(CRPG_32x32_Monopoly_Brick : brick32x32fdata)
	{
		category = "CityRPG";
		subCategory = "Monopoly Lots";
		uiName = "32x32 Business";
		iconName = $CRPG::Path::Images @ "brickIcons/Icon_32x32_Monopoly";
		
		price = 40000;
		crpgLot = true;
		triggerDatablock = "CRPG_Monopoly_Trigger";
		triggerSize = "32 32" SPC $CRPG::TriggerSize;
	};
	
	LotSS.add(CRPG_32x32_Monopoly_Brick);
}

if(!isObject(CRPG_64x64_Monopoly_Brick))
{
	datablock fxDTSBrickData(CRPG_64x64_Monopoly_Brick : brick64x64fdata)
	{
		category = "CityRPG";
		subCategory = "Monopoly Lots";
		uiName = "64x64 Business";
		iconName = $CRPG::Path::Images @ "brickIcons/Icon_64x64_Monopoly";
		
		price = 80000;
		crpgLot = true;
		triggerDatablock = "CRPG_Monopoly_Trigger";
		triggerSize = "64 64" SPC $CRPG::TriggerSize;
	};
	
	LotSS.add(CRPG_64x64_Monopoly_Brick);
}

// Trigger Zones
if(!isObject(CRPG_Car_Lot_Brick))
{
	datablock fxDTSBrickData(CRPG_Car_Lot_Brick : brick16x16fdata)
	{
		category = "CityRPG";
		subCategory = "Lots";
		uiName = "Theft Lot";
		iconName = $CRPG::Path::Images @ "brickIcons/Icon_Car_Admin";
		
		adminOnly = true;
		triggerDatablock = "CRPG_Car_Trigger";
		triggerSize = "16 16 20";
	};
	
	LotSS.add(CRPG_Car_Lot_Brick);
}

if(!isObject(CRPG_Jail_Lot_Brick))
{
	datablock fxDTSBrickData(CRPG_Jail_Lot_Brick : brick16x16fdata)
	{
		category = "CityRPG";
		subCategory = "Lots";
		uiName = "Jail Lot";
		iconName = $CRPG::Path::Images @ "brickIcons/Icon_Jail_Lot_Admin";
		
		adminOnly = true;
		triggerDatablock = "CRPG_Jail_Trigger";
		triggerSize = "16 16" SPC $CRPG::TriggerSize;
	};
	
	LotSS.add(CRPG_Jail_Lot_Brick);
}

// Spawns
if(!isObject(CRPG_Personal_Spawn_Brick))
{
	datablock fxDTSBrickData(CRPG_Personal_Spawn_Brick : brickSpawnPointData)
	{
		uiName = "Personal Spawn";
		category = "CityRPG";
		subCategory = "Spawn Points";
		
		price = 250;
		personalSpawn = true;
		crpgSpawn = true;
	};
}

if(!isObject(CRPG_Jail_Spawn_Brick))
{
	datablock fxDTSBrickData(CRPG_Jail_Spawn_Brick : brickSpawnPointData)
	{
		uiName = "Inmate Spawn";
		category = "CityRPG";
		subCategory = "Spawn Points";
		iconName = $CRPG::Path::Images @ "brickIcons/Icon_SpawnPoint_Admin";
		
		adminOnly = true;
		crpgSpawn = true;
	};
}

if(!isObject(CRPG_Medical_Spawn_Brick))
{
	datablock fxDTSBrickData(CRPG_Medical_Spawn_Brick : brickSpawnPointData)
	{
		uiName = "Medical Spawn";
		category = "CityRPG";
		subCategory = "Spawn Points";
		iconName = $CRPG::Path::Images @ "brickIcons/Icon_SpawnPoint_Admin";
		
		adminOnly = true;
		crpgSpawn = true;
	};
}

// Resources
function CRPG_Tree_Brick::onChop(%this, %brick, %client)
{
	if(isObject(%client))
	{
		%profile = %client.profile;
		
		if(isObject(%profile))
		{
			%min = 1;
			%min += mFloor(%profile.getJob().getLaborBonus(%client) / 2);
			%max = 4 * (mClamp(%profile.hunger, 0, 50) / 50);
			%max += %profile.getJob().getLaborBonus(%client);
			%chance = getRandom(%min, mClamp(%max, 1, %max));
			%brick.strikes += %chance;
			
			if(%brick.strikes >= %this.integrity)
			{
				%brick.onResourceDepleat(%client);
				%brick.strikes = 0;
				%profile.hunger = mClamp(%profile.hunger - 1, 0, %profile.hunger);
				%profile.addEXP(2, "Labor");
				commandToClient(%client, 'BottomPrint', "<just:center>\c6BRICK HARVESTED!", 2);
			}
			else
			{
				%worked = mFloor(100 * (%brick.strikes / %this.integrity));
				%client.sendProgress(%worked, "HARVESTING BRICK");
			}
		}
	}
	
	parent::onChop(%this, %brick, %client);
	return true;
}

function CRPG_Tree_Brick::onPlant(%this, %brick)
{
	parent::onPlant(%this, %brick);
	
	if(!isObject($LastLoadedBrick) || $LastLoadedBrick.getID() != %brick.getID())
	{
		%brick.numEvents								= 2;
		
		%brick.eventEnabled[0]						= true;
		%brick.eventDelay[0]							= 0;
		%brick.eventInput[0]							= "onResourceDepleat";
		%brick.eventInputIdx[0]						= inputEvent_GetInputEventIdx("onResourceDepleat");
		%brick.eventTarget[0]						= "Self";
		%brick.eventTargetIdx[0]					= "0";
		%brick.eventOutput[0]						= "disappear";
		%brick.eventOutputAppendClient[0]		= true;
		%brick.eventOutputIdx[0]					= outputEvent_getOutputEventIdx("fxDTSBrick", "disappear");
		%brick.eventOutputParameter[0, 1]		= 45;
		
		%brick.eventEnabled[1]						= true;
		%brick.eventDelay[1]							= 0;
		%brick.eventInput[1]							= "onResourceDepleat";
		%brick.eventInputIdx[1]						= inputEvent_GetInputEventIdx("onResourceDepleat");
		%brick.eventTarget[1]						= "Self";
		%brick.eventTargetIdx[1]					= "0";
		%brick.eventOutput[1]						= "explodePlastic";
		%brick.eventOutputAppendClient[1]		= true;
		%brick.eventOutputIdx[1]					= outputEvent_getOutputEventIdx("fxDTSBrick", "explodePlastic");
		%brick.eventOutputParameter[1, 1]		= 45;
	}
}

if(!isObject(CRPG_Tree_Brick))
{
	datablock fxDTSBrickData(CRPG_Tree_Brick)
	{
		uiName = "Plastic Tree";
		category = "CityRPG";

		brickFile	= $CRPG::Path::Bricks @ "TreeStump.blb";
		iconName = $CRPG::Path::Images @ "brickIcons/Icon_TreeStump_Admin";
		subCategory = "Resources";
		
		adminOnly		= true;
		isTree			= true;
		integrity		= 25;
		payoutMin		= 10;
		payoutMax		= 15;
	};
}

function CRPG_Ore_Brick::onMine(%this, %brick, %client)
{
	if(isObject(%client))
	{
		%profile = %client.profile;
		
		if(isObject(%profile))
		{
			%min = 1;
			%min += mFloor(%profile.getJob().getLaborBonus(%client) / 2);
			%max = 4 * (mClamp(%profile.hunger, 0, 50) / 50);
			%max += %profile.getJob().getLaborBonus(%client);
			%chance = getRandom(%min, mClamp(%max, 1, %max));
			%brick.strikes += %chance;
			
			%worked = mFloor(100 * (%brick.strikes / %this.integrity));
			%client.sendProgress(%worked, "HARVESTING BRICK");
			
			if(%brick.strikes >= %this.integrity)
			{
				%brick.onResourceDepleat(%client);
				%brick.strikes = 0;
				%profile.hunger = mClamp(%profile.hunger - 1, 0, %profile.hunger);
				%profile.addEXP(3, "Labor");
			}
		}
	}
	
	parent::onMine(%this, %brick, %client);
}

function CRPG_Ore_Brick::onPlant(%this, %brick)
{
	parent::onPlant(%this, %brick);
	
	if(!isObject($LastLoadedBrick) || $LastLoadedBrick.getID() != %brick.getID())
	{
		%brick.numEvents								= 2;
		
		%brick.eventEnabled[0]						= true;
		%brick.eventDelay[0]							= 0;
		%brick.eventInput[0]							= "onResourceDepleat";
		%brick.eventInputIdx[0]						= inputEvent_GetInputEventIdx("onResourceDepleat");
		%brick.eventTarget[0]						= "Self";
		%brick.eventTargetIdx[0]					= "0";
		%brick.eventOutput[0]						= "disappear";
		%brick.eventOutputAppendClient[0]		= true;
		%brick.eventOutputIdx[0]					= outputEvent_getOutputEventIdx("fxDTSBrick", "disappear");
		%brick.eventOutputParameter[0, 1]		= 45;
		
		%brick.eventEnabled[1]						= true;
		%brick.eventDelay[1]							= 0;
		%brick.eventInput[1]							= "onResourceDepleat";
		%brick.eventInputIdx[1]						= inputEvent_GetInputEventIdx("onResourceDepleat");
		%brick.eventTarget[1]						= "Self";
		%brick.eventTargetIdx[1]					= "0";
		%brick.eventOutput[1]						= "explodePlastic";
		%brick.eventOutputAppendClient[1]		= true;
		%brick.eventOutputIdx[1]					= outputEvent_getOutputEventIdx("fxDTSBrick", "explodePlastic");
		%brick.eventOutputParameter[1, 1]		= 45;
	}
}

if(!isObject(CRPG_Ore_Brick))
{
	datablock fxDTSBrickData(CRPG_Ore_Brick)
	{
		brickFile		= $CRPG::Path::Bricks @ "4x Cube.blb";
		category			= "CityRPG";
		subCategory		= "Resources";
		uiName			= "Ore";
		iconName			= $CRPG::Path::Images @ "brickIcons/Icon_4xCube_Admin";
		
		adminOnly		= true;
		isRock			= true;
		integrity		= 50;
		payoutMin		= 20;
		payoutMax		= 35;
	};
}

// ============================================================
// Section 4 : Emitters
// ============================================================
// Baton
if(!isObject(CRPG_Baton_Particle))
{
	datablock ParticleData(CRPG_Baton_Particle)
	{
		dragCoefficient		= 2;
		gravityCoefficient	= 1.0;
		inheritedVelFactor	= 0.2;
		constantAcceleration = 0.0;
		spinRandomMin = -90;
		spinRandomMax = 90;
		lifetimeMS			  = 500;
		lifetimeVarianceMS	= 300;
		textureName			 = "base/data/particles/chunk";
		colors[0]	  = "4 5 2 4";
		colors[1]	  = "0.5 0.4 0.5 0.0";
		sizes[0]		= 0.5;
		sizes[1]		= 0.25;
	};
}

if(!isObject(CRPG_Baton_Emitter))
{
	datablock ParticleEmitterData(CRPG_Baton_Emitter)
	{
		ejectionPeriodMS = 7;
		periodVarianceMS = 0;
		ejectionVelocity = 8;
		velocityVariance = 1.0;
		ejectionOffset	= 0.0;
		thetaMin			= 0;
		thetaMax			= 60;
		phiReferenceVel  = 0;
		phiVariance		= 360;
		overrideAdvance = false;
		particles = "CRPG_Baton_Particle";

		uiName = "baton Hit";
	};
}

if(!isObject(CRPG_Baton_Explosion))
{
	datablock ExplosionData(CRPG_Baton_Explosion)
	{
		lifeTimeMS = 500;

		soundProfile = CRPG_Wood_Hit_Sound;

		particleEmitter = CRPG_Baton_Emitter;
		particleDensity = 10;
		particleRadius = 0.2;

		faceViewer	  = true;
		explosionScale = "1 1 1";

		shakeCamera = true;
		camShakeFreq = "10.0 12.0 10.0";
		camShakeAmp = "0.5 0.5 0.5";
		camShakeDuration = 0.5;
		camShakeRadius = 5.0;

		// Dynamic light
		lightStartRadius = 3;
		lightEndRadius = 0;
		lightStartColor = "0.3 0.4 0.6 0";
		lightEndColor = "0.9 0.9 0.9 0";
	};
}

if(!isObject(CRPG_Baton_Projectile))
{
	datablock ProjectileData(CRPG_Baton_Projectile)
	{
		directDamage		= 10;
		directDamageType 	= $DamageType::CRPGBaton;
		radiusDamageType 	= $DamageType::CRPGBaton;
		explosion			= CRPG_Baton_Explosion;
		
		muzzleVelocity		= 50;
		velInheritFactor	= 1;
		
		armingDelay			= 0;
		lifetime				= 100;
		fadeDelay			= 70;
		bounceElasticity	= 0;
		bounceFriction		= 0;
		isBallistic			= false;
		gravityMod			= 0.0;
		
		hasLight				= false;
		lightRadius			= 1.0;
		lightColor			= "0.5 0 0";
	};
}

// Bounce
if(!isObject(CRPG_Bounce_Explosion))
{
	datablock ExplosionData(CRPG_Bounce_Explosion)
	{
		shakeCamera			= true;
		camShakeAmp			= "0.5 0.5 0.5";
		camShakeDuration	= 0.1;
		camShakeFalloff	= 0;
		camShakeFreq		= "10.0 12.0 10.0";
		camShakeRadius		= 10;
	};
}

if(!isObject(CRPG_Bounce_Projectile))
{
	datablock ProjectileData(CRPG_Bounce_Projectile)
	{
		directDamage	= 0;
		explosion		= CRPG_Bounce_Explosion;
		lifetime			= 0;
	};
}

// Cellphone
if(!isObject(CRPG_Cellphone_Particle))
{
	datablock ParticleData(CRPG_Cellphone_Particle)
	{
		dragCoefficient		= 2.5;
		gravityCoefficient	= 6;
		inheritedVelFactor	= 0;
		constantAcceleration = 0;
		spinRandomMin			= -150;
		spinRandomMax			= 150;
		spinSpeed				= 500;
		lifetimeMS				= 1000;
		lifetimeVarianceMS	= 0;
		textureName				= $CRPG::Path::Images @ "particles/cellphone";
		colors[0]				= "1.0 0.8 0.6 1.0";
		colors[1]				= "0.5 0.4 0.5 0.0";
		sizes[0]					= 0.50;
		sizes[1]					= 0.25;
	};
}

if(!isObject(CRPG_Cellphone_Emitter))
{
	datablock ParticleEmitterData(CRPG_Cellphone_Emitter)
	{
		particles				= CRPG_Cellphone_Particle;
		uiName					= "Cellphone Search";
		
		doDetail					= true;
		doFallOff				= true;
		
		ejectionOffset			= 0;
		ejectionPeriodMS		= 14;
		ejectionVelocity		= 32;
		
		orientOnVelocity		= true;
		orientParticles		= false;
		overrideAdvance		= false;
		
		periodVarianceMS		= 0;
		phiReferenceVel		= 0;
		phiVariance				= 360;
		
		thetaMin					= 85;
		thetaMax					= 90;
		
		velocityVariance		= 0;
	};
}

if(!isObject(CRPG_Cellphone_Explosion))
{
	datablock ExplosionData(CRPG_Cellphone_Explosion)
	{
		lifeTimeMS = 1000;

		soundProfile = CRPG_Search_Sound;

		particleEmitter = CRPG_Cellphone_Emitter;
		particleDensity = 96;
		particleRadius = 1.0;
		
		faceViewer	  = true;
		explosionScale = "1 1 1";

		shakeCamera = false;
		camShakeFreq = "10.0 12.0 10.0";
		camShakeAmp = "0.5 0.5 0.5";
		camShakeDuration = 0.5;
		camShakeRadius = 5.0;

		// Dynamic light
		lightStartRadius = 32;
		lightEndRadius = 0;
		lightStartColor = "0.6 0.4 0.3 0";
		lightEndColor = "0.9 0.9 0.9 0";
	};
}

if(!isObject(CRPG_Cellphone_Projectile))
{
	datablock ProjectileData(CRPG_Cellphone_Projectile)
	{
		directDamage		= 0;
		directDamageType 	= $DamageType::Direct;
		radiusDamageType 	= $DamageType::Direct;
		explosion			= CRPG_Cellphone_Explosion;
		
		muzzleVelocity		= 50;
		velInheritFactor	= 1;
		
		armingDelay			= 0;
		lifetime				= 100;
		fadeDelay			= 70;
		bounceElasticity	= 0;
		bounceFriction		= 0;
		isBallistic			= false;
		gravityMod			= 0.0;
		
		hasLight				= false;
		lightRadius			= 1.0;
		lightColor			= "0.5 0 0";
	};
}

// Death Smoke
if(!isObject(CRPG_Death_Particle))
{
	datablock ParticleData(CRPG_Death_Particle)
	{
		textureName						= "base/data/particles/cloud";
		dragCoefficient				= 0.0;
		gravityCoefficient		= -0.25;
		inheritedVelFactor		= 0.0;
		windCoefficient				= 0;
		constantAcceleration	= 0;
		lifetimeMS						= 1000;
		lifetimeVarianceMS		= 250;
		spinSpeed							= 0;
		spinRandomMin					= -30.0;
		spinRandomMax					=  30.0;
		useInvAlpha						= true;
		
		colors[0]	  = "0.200 0.200 0.200 0.900";
		colors[1]	  = "0.500 0.500 0.500 0.800";
		colors[2]	  = "0.600 0.600 0.600 0.700";
		colors[3]	  = "0.600 0.600 0.600 0.000";
		
		sizes[0]	= 1.75;
		sizes[1]	= 3.50;
		sizes[2]	= 2.00;
		sizes[3]	= 0.75;
		
		times[0]	= 0.0;
		times[1]	= 0.15;
		times[2]	= 0.8;
		times[3]	= 1.5;
	};
}

if(!isObject(CRPG_Death_Emitter))
{
	datablock ParticleEmitterData(CRPG_Death_Emitter)
	{
		ejectionPeriodMS	= 50;
		periodVarianceMS	= 10;
		ejectionVelocity	= 0;
		ejectionOffset		= 0.4;
		velocityVariance	= 0.0;
		thetaMin					= 0;
		thetaMax					= 5;
		phiReferenceVel		= 0;
		phiVariance				= 360;
		overrideAdvance		= false;
		
		particles = CRPG_Death_Particle;	
		
		uiName = "Death Smoke";
	};
}

// Flash
if(!isObject(CRPG_Flash_Particle))
{
	datablock ParticleData(CRPG_Flash_Particle)
	{
		dragCoefficient		= 3;
		gravityCoefficient	= -0.5;
		inheritedVelFactor	= 0.2;
		constantAcceleration = 0.0;
		lifetimeMS			  = 25;
		lifetimeVarianceMS	= 15;
		textureName			 = $CRPG::Path::Shapes @ "newflash";
		spinSpeed		= 10.0;
		spinRandomMin		= -500.0;
		spinRandomMax		= 500.0;
		colors[0]	  = "0.9 0.9 0.0 0.9";
		colors[1]	  = "0.9 0.5 0.0 0.0";
		sizes[0]		= 0.5;
		sizes[1]		= 1.0;

		useInvAlpha = false;
	};
}

if(!isObject(CRPG_Flash_Emitter))
{
	datablock ParticleEmitterData(CRPG_Flash_Emitter)
	{
		ejectionPeriodMS = 3;
		periodVarianceMS = 0;
		ejectionVelocity = 1.0;
		velocityVariance = 1.0;
		ejectionOffset	= 0.0;
		thetaMin			= 0;
		thetaMax			= 90;
		phiReferenceVel  = 0;
		phiVariance		= 360;
		overrideAdvance = false;
		particles = "CRPG_Flash_Particle";

		uiName = "Gun Flash 2";
	};
}

// Handcuff
if(!isObject(CRPG_Handcuff_Debris))
{
	datablock DebrisData(CRPG_Handcuff_Debris)
	{
		shapeFile = $CRPG::Path::Shapes @ "Handcuffs_Item.dts";
		lifetime = 10;
		minSpinSpeed = -400.0;
		maxSpinSpeed = 400.0;
		elasticity = 0.5;
		friction = 0.2;
		numBounces = 3;
		staticOnMaxBounce = true;
		snapOnMaxBounce = false;
		fade = true;
		gravModifier = 2;
	};
}

if(!isObject(CRPG_Handcuff_Explosion))
{
	datablock ExplosionData(CRPG_Handcuff_Explosion)
	{
		lifetimeMS = 33;
		particleEmitter = "";
		debris = CRPG_Handcuff_Debris;
		debrisNum				  = 1;
		debrisNumVariance		= 0;
		debrisPhiMin			  = 0;
		debrisPhiMax			  = 360;
		debrisThetaMin			= 0;
		debrisThetaMax			= 180;
		debrisVelocity			= 5;
		debrisVelocityVariance = 0;
		
		faceViewer	  = true;
		explosionScale = "1 1 1";
		
		shakeCamera = false;
		
		lightStartRadius = 0;
		lightEndRadius = 0;
		
		impulseRadius = 100;
		impulseForce = 100;
		
		radiusDamage = 0;
		damageRadius = 0;
		
		uiName = "";
	};
}

if(!isObject(CRPG_Handcuff_Projectile))
{
	datablock ProjectileData(CRPG_Handcuff_Projectile)
	{
		directDamage		= 0;
		directDamageType 	= $DamageType::Direct;
		radiusDamageType 	= $DamageType::Direct;
		explosion			= CRPG_Handcuff_Explosion;
		
		muzzleVelocity		= 50;
		velInheritFactor	= 1;
		
		armingDelay			= 0;
		lifetime				= 100;
		fadeDelay			= 70;
		bounceElasticity	= 0;
		bounceFriction		= 0;
		isBallistic			= false;
		gravityMod			= 0.0;
		
		hasLight				= false;
		lightRadius			= 1.0;
		lightColor			= "0.5 0 0";
	};
}

// Magnifying Glass
if(!isObject(CRPG_Magnify_Particle))
{
	datablock ParticleData(CRPG_Magnify_Particle)
	{
		dragCoefficient		= 2.5;
		gravityCoefficient	= 0;
		inheritedVelFactor	= 0;
		constantAcceleration = 0;
		spinRandomMin			= -150;
		spinRandomMax			= 150;
		spinSpeed				= 500;
		lifetimeMS				= 1000;
		lifetimeVarianceMS	= 0;
		textureName				= $CRPG::Path::Images @ "particles/magnifying_glass";
		colors[0]				= "0.6 0.8 1.0 1.0";
		colors[1]				= "0.5 0.4 0.5 0.0";
		sizes[0]					= 0.50;
		sizes[1]					= 0.25;
	};
}

if(!isObject(CRPG_Magnify_Emitter))
{
	datablock ParticleEmitterData(CRPG_Magnify_Emitter)
	{
		particles				= CRPG_Magnify_Particle;
		uiName					= "Magnify";
		
		doDetail					= true;
		doFallOff				= true;
		
		ejectionOffset			= 0;
		ejectionPeriodMS		= 14;
		ejectionVelocity		= 22.5;
		
		orientOnVelocity		= true;
		orientParticles		= false;
		overrideAdvance		= false;
		
		periodVarianceMS		= 0;
		phiReferenceVel		= 0;
		phiVariance				= 360;
		
		thetaMin					= 85;
		thetaMax					= 90;
		
		velocityVariance		= 0;
	};
}

if(!isObject(CRPG_Magnify_Explosion))
{
	datablock ExplosionData(CRPG_Magnify_Explosion)
	{
		lifeTimeMS = 1000;

		soundProfile = CRPG_Search_Sound;

		particleEmitter = CRPG_Magnify_Emitter;
		particleDensity = 96;
		particleRadius = 1.0;
		
		faceViewer	  = true;
		explosionScale = "1 1 1";

		shakeCamera = false;
		camShakeFreq = "10.0 12.0 10.0";
		camShakeAmp = "0.5 0.5 0.5";
		camShakeDuration = 0.5;
		camShakeRadius = 5.0;

		// Dynamic light
		lightStartRadius = 24;
		lightEndRadius = 0;
		lightStartColor = "0.3 0.4 0.6 0";
		lightEndColor = "0.9 0.9 0.9 0";
	};
}

if(!isObject(CRPG_Magnify_Projectile))
{
	datablock ProjectileData(CRPG_Magnify_Projectile)
	{
		directDamage		= 0;
		directDamageType 	= $DamageType::Direct;
		radiusDamageType 	= $DamageType::Direct;
		explosion			= CRPG_Magnify_Explosion;
		
		muzzleVelocity		= 50;
		velInheritFactor	= 1;
		
		armingDelay			= 0;
		lifetime				= 100;
		fadeDelay			= 70;
		bounceElasticity	= 0;
		bounceFriction		= 0;
		isBallistic			= false;
		gravityMod			= 0.0;
		
		hasLight				= false;
		lightRadius			= 1.0;
		lightColor			= "0.5 0 0";
	};
}

// Muzzle Smoke
if(!isObject(CRPG_Smoke_Particle))
{
	datablock ParticleData(CRPG_Smoke_Particle)
	{
		dragCoefficient		= 3;
		gravityCoefficient	= -0.5;
		inheritedVelFactor	= 0.2;
		constantAcceleration = 0.0;
		lifetimeMS			  = 525;
		lifetimeVarianceMS	= 55;
		textureName			 = "base/data/particles/cloud";
		spinSpeed		= 10.0;
		spinRandomMin		= -500.0;
		spinRandomMax		= 500.0;
		colors[0]	  = "0.5 0.5 0.5 0.9";
		colors[1]	  = "0.5 0.5 0.5 0.0";
		sizes[0]		= 0.15;
		sizes[1]		= 0.15;

		useInvAlpha = false;
	};
}

if(!isObject(CRPG_Smoke_Emitter))
{
	datablock ParticleEmitterData(CRPG_Smoke_Emitter)
	{
		ejectionPeriodMS = 3;
		periodVarianceMS = 0;
		ejectionVelocity = 1.0;
		velocityVariance = 1.0;
		ejectionOffset	= 0.0;
		thetaMin			= 0;
		thetaMax			= 90;
		phiReferenceVel  = 0;
		phiVariance		= 360;
		overrideAdvance = false;
		particles = "CRPG_Smoke_Particle";
	};
}

// Pickaxe
if(!isObject(CRPG_Pickaxe_Explosion))
{
	datablock ExplosionData(CRPG_Pickaxe_Explosion)
	{
		lifeTimeMS = 500;

		soundProfile = CRPG_Metal_Hit_Sound;

		particleEmitter = CRPG_Baton_Emitter;
		particleDensity = 10;
		particleRadius = 0.2;

		faceViewer	  = true;
		explosionScale = "1 1 1";

		shakeCamera = true;
		camShakeFreq = "10.0 12.0 10.0";
		camShakeAmp = "0.5 0.5 0.5";
		camShakeDuration = 0.5;
		camShakeRadius = 5.0;

		// Dynamic light
		lightStartRadius = 3;
		lightEndRadius = 0;
		lightStartColor = "0.8 0.3 0.2 0";
		lightEndColor = "0.9 0.9 0.9 0";
	};
}

if(!isObject(CRPG_Pickaxe_Projectile))
{
	datablock ProjectileData(CRPG_Pickaxe_Projectile)
	{
		directDamage		= 10;
		directDamageType 	= $DamageType::CRPGPickaxe;
		radiusDamageType 	= $DamageType::CRPGPickaxe;
		explosion			= CRPG_Pickaxe_Explosion;
		
		muzzleVelocity		= 50;
		velInheritFactor	= 1;
		
		armingDelay			= 0;
		lifetime				= 100;
		fadeDelay			= 70;
		bounceElasticity	= 0;
		bounceFriction		= 0;
		isBallistic			= false;
		gravityMod			= 0.0;
		
		hasLight				= false;
		lightRadius			= 1.0;
		lightColor			= "0.5 0 0";
	};
}

// Star
if(!isObject(CRPG_Explosion_Star_Particle))
{
	datablock ParticleData(CRPG_Explosion_Star_Particle)
	{
		dragCoefficient		= 8;
		gravityCoefficient	= 0;
		inheritedVelFactor	= 0.2;
		constantAcceleration	= 0.0;
		lifetimeMS				= 20;
		lifetimeVarianceMS	= 0;
		textureName				= "base/data/particles/star1";
		spinSpeed				= 0.0;
		spinRandomMin			= 0.0;
		spinRandomMax			= 0.0;
		colors[0]				= "1 1 0.0 0.9";
		colors[1]				= "0.9 0.0 0.0 0.0";
		sizes[0]					= 1;
		sizes[1]					= 2;
		useInvAlpha				= false;
	};
}

if(!isObject(CRPG_Explosion_Star_Emitter))
{
	datablock ParticleEmitterData(CRPG_Explosion_Star_Emitter)
	{
		lifeTimeMS			= 50;
		ejectionPeriodMS	= 3;
		periodVarianceMS	= 0;
		ejectionVelocity	= 0;
		velocityVariance	= 0.0;
		ejectionOffset		= 0.0;
		thetaMin				= 89;
		thetaMax				= 90;
		phiReferenceVel	= 0;
		phiVariance			= 360;
		overrideAdvance	= false;
		particles			= "CRPG_Explosion_Star_Particle";
	};
}

// Stun

datablock ParticleData(CRPG_Stun_Particle)
{
	dragCoefficient		= 8;
	gravityCoefficient	= 0;
	inheritedVelFactor	= 0.2;
	constantAcceleration	= 0.0;
	lifetimeMS				= 100;
	lifetimeVarianceMS	= 0;
	textureName				= "base/data/particles/star1";
	spinSpeed				= 10.0;
	spinRandomMin			= -10.0;
	spinRandomMax			= 10.0;
	colors[0]				= "1 1 0.0 0.9";
	colors[1]				= "0.9 0.0 0.0 0.0";
	sizes[0]					= 0.2;
	sizes[1]					= 0;
	useInvAlpha				= false;
};

datablock ParticleEmitterData(CRPG_Stun_Emitter)
{
	periodVarianceMS	= 0;
	ejectionVelocity	= 0.0;
	velocityVariance	= 0.0;
	ejectionOffset		= 0.5;
	thetaMin				= 90;
	thetaMax				= 90.1;
	phiVariance			= 0;
	overrideAdvance	= false;
	particles			= "CRPG_Stun_Particle";

	ejectionPeriodMS	= 1;
	phiReferenceVel	= 60480;
	
	uiName				= "Emote - Stun";
};

datablock ShapeBaseImageData(CRPG_Stun_Image)
{
	shapeFile	= "base/data/shapes/empty.dts";
	emap			= false;

	mountPoint	= $BackSlot;
	rotation		= "1 0 0 -90";
	offset		= "0 0 1.15";

	stateName[0]						= "Ready";
	stateTimeoutValue[0]				= 0.01;
	stateTransitionOnTimeout[0]	= "FireA";

	stateName[1]						= "FireA";
	stateEmitter[1]					= CRPG_Stun_Emitter;
	stateEmitterTime[1]				= 10000;
	stateTimeoutValue[1]				= 10000;
	stateTransitionOnTimeout[1]	= "FireA";
	stateWaitForTimeout[1]			= true;
};

// ============================================================
// Section 5 : Shapes
// ============================================================

// Baton
function CRPG_Baton_Image::onPreFire(%this, %obj, %slot)
{
	%obj.playThread(2, "armattack");
}

function CRPG_Baton_Image::onRaycastDamage(%this, %obj, %slot, %col, %pos, %normal, %shotVec, %crit)
{
	// Player Stunning
	if(!(%col.getType() & $TypeMasks::PlayerObjectType))
		return 0;
	
	if(!isObject(%col.client) || !(%col.client.profile.getWantedLevel() || %obj.client.crpgEvil))
		return 0;
	
	if(!%col.crpgStunned)
		return 0;
	
	%damageType = $DamageType::Direct;
	
	if(%this.raycastDirectDamageType)
		%damageType = %this.raycastDirectDamageType;
	
	%directDamage = mClampF(%this.raycastDirectDamage, 0, %col.getDatablock().maxDamage - %col.getDamageLevel() - 1);
	
	if(%directDamage > 0)
		%col.damage(%obj, %pos, %directDamage, %damageType);
	
	if(%col.getDatablock().maxDamage - %col.getDamageLevel() == 1)
	{
		%time = 10;
		%time -= (%col.client.profile.getBeliefAnarchy() / 2);
		
		if(isObject(%obj.client.profile))
			%time += (%obj.client.profile.getBeliefOrder() / 2);
		
		%col.setStunned(%time);
	}
}

function CRPG_Baton_Image::onRaycastDamageBrick(%this, %obj, %slot, %col, %pos, %normal, %shotVec, %crit)
{
	if(%col.client.crpgEvil)
		return parent::onRaycastDamageBrick(%this, %obj, %slot, %col, %pos, %normal, %shotVec, %crit);
	
	%lot = %col.getLot();
	
	if(isObject(%lot) && %lot.isCrimeHarbor(%obj.client))
		return parent::onRaycastDamageBrick(%this, %obj, %slot, %col, %pos, %normal, %shotVec, %crit);
}

function CRPG_Baton_Image::onStopFire(%this, %obj, %slot)
{
	%obj.playThread(2, "root");
}

if(!isObject(CRPG_Baton_Item))
{
	datablock ItemData(CRPG_Baton_Item)
	{
		category		= "Weapon";
		className	= "Weapon";
		
		mass			= 1;
		density		= 0.2;
		elasticity	= 0.2;
		friction		= 0.6;
		emap			= true;
		
		uiName		= "Police Baton";
		shapeFile	= $CRPG::Path::Shapes @ "Baton.dts";
		iconName		= $CRPG::Path::Images @ "itemIcons/Icon_Baton";
		
		doColorShift		= true;
		colorShiftColor	= "0.150 0.150 0.150 1.000";
		
		image		= CRPG_Baton_Image;
		canDrop	= false;
	};
}

if(!isObject(CRPG_Baton_Image))
{
	datablock ShapeBaseImageData(CRPG_Baton_Image)
	{
		// Raycast Properties
		raycastWeaponRange				= 6;
		raycastWeaponTargets				= ($TypeMasks::FxBrickObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType);
		raycastWeaponPierceTargets		= 0;
		raycastDirectDamage				= 35;
		raycastDirectDamageType			= $DamageType::CRPGBaton;
		raycastCritDirectDamageType	= $DamageType::CRPGBaton;
		raycastExplosionProjectile		= CRPG_Baton_Projectile;
		raycastExplosionSound			= 0;
		raycastExplosionPlayerSound	= 0;
		raycastExplosionBrickSound		= 0;
		raycastSpreadAmt					= 0;	
		raycastSpreadCount				= 1;
		raycastTracerProjectile			= 0;
		
		raycastFromMuzzle					= false;
		shapeFile = $CRPG::Path::Shapes @ "Baton.dts";
		emap = true;
		
		mountPoint = 0;
		offset = "0 0 0";
		
		correctMuzzleVector = false;
		className = "WeaponImage";
		
		item = CRPG_Baton_Item;
		ammo = " ";
		projectile = CRPG_Baton_Projectile;
		projectileType = Projectile;
		
		melee = true;
		doRetraction = false;
		armReady = true;
		
		doColorShift = true;
		colorShiftColor = "0.150 0.150 0.150 1.000";
		
		stateName[0]							= "Activate";
		stateTimeoutValue[0]					= 0.5;
		stateTransitionOnTimeout[0]		= "Ready";
		
		stateName[1]							= "Ready";
		stateTransitionOnTriggerDown[1]	= "PreFire";
		stateAllowImageChange[1]			= true;
		
		stateName[2]							= "PreFire";
		stateScript[2]							= "onPreFire";
		stateAllowImageChange[2]			= false;
		stateTimeoutValue[2]					= 0.1;
		stateTransitionOnTimeout[2]		= "Fire";
		
		stateName[3]							= "Fire";
		stateTransitionOnTimeout[3]		= "CheckFire";
		stateTimeoutValue[3]					= 0.2;
		stateFire[3]							= true;
		stateAllowImageChange[3]			= false;
		stateSequence[3]						= "Fire";
		stateScript[3]							= "onFire";
		stateWaitForTimeout[3]				= true;
		
		stateName[4]							= "CheckFire";
		stateTransitionOnTriggerUp[4]		= "StopFire";
		stateTransitionOnTriggerDown[4]	= "Fire";
		
		stateName[5]							= "StopFire";
		stateTransitionOnTimeout[5]		= "Ready";
		stateTimeoutValue[5]					= 0.2;
		stateAllowImageChange[5]			= false;
		stateWaitForTimeout[5]				= true;
		stateSequence[5]						= "StopFire";
		stateScript[5]							= "onStopFire";
	};
}

// Cellphone
function CRPG_Cellphone_Image::onFire(%this, %obj, %slot)
{
	%client = %obj.client;
	
	if(isObject(%client) && isObject(%profile = %client.profile))
	{
		switch(%obj.weaponMode[CRPG_Drill_Image.getID()])
		{
			case 0:
				if($sim::time - %obj.crpgLastPoliceCall >= 30)
				{
					%obj.crpgLastPoliceCall = $sim::time;
					%obj.spawnExplosion(CRPG_Cellphone_Projectile, 1);
					
					initContainerRadiusSearch(%obj.getPosition(), 24, $TypeMasks::ItemObjectType);
					
					while(isObject(%col = containerSearchNext()))
					{
						if(%col.isClue)
						{
							%start	= %obj.getEyePoint();
							%end		= %col.getWorldBoxCenter();
							%masks	= ($TypeMasks::FxBrickObjectType | $TypeMasks::ItemObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType);
							%hit		= getWord(containerRayCast(%start, %end, %masks, %obj), 0);
							
							if(isObject(%hit) && %col.getID() == %hit.getID())
							{
								%message = %col.clueMessage;
								
								if((isObject(%perp = %col.cluePerp) || isObject(%perp = findClientByBL_ID(%col.clueBLID))) &&
									(isObject(%perpProfile = Profiler.getProfile(%perp.bl_id))))
								{
									%perpProfile.setDemerits(%perpProfile.demerits + %col.clueDems);
									
									if(isObject(%perp) && %perp.bl_id == %client.bl_id)
									{
										messageClient(%client, '', "\c6You have reported your own crime to the police! [\c3" @ %message @ "\c6]");
									}
									else
									{
										messageClient(%perp, '', "\c6A cop discovered evidence pinning you with a crime! [\c3" @ %message @ "\c6]");
										messageClient(%client, '', "\c6You have reported a crime to the police! [\c3" @ %message @ "\c6]");
									}
									
									SystemSO.unsolved--;
									SystemSO.solved++;
									%count++;
								}
								else if(isObject(%perpProfile = Profiler.getProfile(%col.clueBLID)))
								{
									%perpProfile.setDemerits(%perpProfile.demerits + %col.clueDems);
									messageClient(%client, '', "\c6You have reported a crime to the police! [\c3" @ %message @ "\c6]");
									
									SystemSO.unsolved--;
									SystemSO.solved++;
									%count++;
								}
								
								%col.delete();
							}
						}
					}
					
					if(%count)
						messageClient(%client, '', "\c6Your phonecall uncovered \c3" @ %count @ "\c6 useful clues!");
					else
						messageClient(%client, '', "\c6Your phonecall resulted in no evidence being found.");
				}
				else
				{
					%time = $sim::time - %obj.crpgLastPoliceCall;
					%time = 29 - mFloor(%time);
					%suffix = %time > 1 ? "s" : "";
					
					commandToClient(%client, 'CenterPrint', "\c6You must wait another \c3" @ (%time + 1) @ "\c6 second" @ %suffix @ ".", 2);
				}
		}
	}
}

if(!isObject(CRPG_Cellphone_Item))
{
	datablock ItemData(CRPG_Cellphone_Item)
	{
		category		= "Weapon";
		className	= "Weapon";
		
		mass			= 1;
		density		= 0.2;
		elasticity	= 0.2;
		friction		= 0.6;
		emap			= true;
		
		uiName		= "Cellphone";
		shapeFile	= $CRPG::Path::Shapes @ "Cellphone.dts";
		iconName		= $CRPG::Path::Images @ "itemIcons/Icon_Cellphone";
		
		doColorShift		= true;
		colorShiftColor	= "1 1 1 1";
		
		image		= CRPG_Cellphone_Image;
		canDrop	= true;
	};
}

if(!isObject(CRPG_Cellphone_Image))
{
	datablock ShapeBaseImageData(CRPG_Cellphone_Image)
	{
		numModes = 1;
		mode[0] = "911 Mode";
		
		shapeFile	= $CRPG::Path::Shapes @ "Cellphone.dts";
		emap			= true;

		mountPoint	= 0;
		offset		= "0 0 0";
		eyeOffset	= "0.0 0.0 0.0";
		rotation		= eulerToMatrix( "0 0 0" );

		className	= "WeaponImage";
		item			= CRPG_Cellphone_Item;

		melee			= true;
		armReady		= true;

		doColorShift = true;
		colorShiftColor = CRPG_Cellphone_Item.colorShiftColor;
		
		stateName[0]							= "Activate";
		stateTimeoutValue[0]					= 0.5;
		stateTransitionOnTimeout[0]		= "Ready";
		
		stateName[1]							= "Ready";
		stateTransitionOnTriggerDown[1]	= "PreFire";
		stateAllowImageChange[1]			= true;
		
		stateName[2]							= "PreFire";
		stateScript[2]							= "onPreFire";
		stateAllowImageChange[2]			= false;
		stateTimeoutValue[2]					= 0.25;
		stateTransitionOnTimeout[2]		= "Fire";
		
		stateName[3]							= "Fire";
		stateTransitionOnTimeout[3]		= "CheckFire";
		stateTimeoutValue[3]					= 0.5;
		stateFire[3]							= true;
		stateAllowImageChange[3]			= false;
		stateSequence[3]						= "Fire";
		stateScript[3]							= "onFire";
		stateWaitForTimeout[3]				= true;
		
		stateName[4]							= "CheckFire";
		stateTransitionOnTriggerUp[4]		= "StopFire";
		
		stateName[5]							= "StopFire";
		stateTransitionOnTimeout[5]		= "Ready";
		stateTimeoutValue[5]					= 0.2;
		stateAllowImageChange[5]			= false;
		stateWaitForTimeout[5]				= true;
		stateSequence[5]						= "StopFire";
		stateScript[5]							= "onStopFire";
	};
}

// Death
if(!isObject(CRPG_Death_Image))
{
	datablock ShapeBaseImageData(CRPG_Death_Image)
	{
		shapeFile = "base/data/shapes/empty.dts";
		emap = false;

		mountPoint = 0;
		offset = "0 0 0";
		
		firstPersonParticles = false;
		
		stateName[0]							= "Ready";
		stateTimeoutValue[0]				= 0.01;
		stateTransitionOnTimeout[0]	= "FireA";

		stateName[1]							= "FireA";
		stateEmitter[1]						= CRPG_Death_Emitter;
		stateEmitterTime[1]					= 0.9;
		stateTimeoutValue[1]				= 0.9;
		stateTransitionOnTimeout[1]	= "Done";
		stateWaitForTimeout[1]			= true;

		stateName[2]							= "Done";
		stateTimeoutValue[2]				= 0.01;
		stateTransitionOnTimeout[2]	= "FireA";
	};
}

// Drill
function CRPG_Drill_Image::onHitObject(%this, %obj, %slot, %col, %pos, %normal, %shotVec, %crit)
{
	%client = %obj.client;
	
	if(isObject(%client) && isObject(%profile = %client.profile))
	{
		%mode = %obj.weaponMode[CRPG_Drill_Image.getID()];
		
		switch(%mode)
		{
			case 0:
				if(%col.getType() & $TypeMasks::VehicleObjectType)
				{
					%this.raycastDirectDamage = 1;
					%result = parent::onHitObject(%this, %obj, %slot, %col, %pos, %normal, %shotVec, %crit);
					%this.raycastDirectDamage = 0;
					
					%health	= 40 - mFloor(40 * %col.getDamagePercent());
					%message	= "<color:00ff00>";
					
					for(%a = 0; %a < 40; %a++)
						if(%a == %health)
							%message = %message @ "<color:ff0000>|";
						else
							%message = %message @ "|";
					
					if(%col.crpgLastMessage[%client.getID()] != %health || $sim::time - %col.crpgLastMessage[%client.getID()] > 1)
					{
						%col.crpgLastHealth[%client.getID()]	= %health;
						%col.crpgLastMessage[%client.getID()]	= $sim::time;
						commandToClient(%client, 'BottomPrint', "<just:center>\c6VEHICLE HEALTH" NL %message, 2);
					}
				}
			
			case 1:
				if(%col.getType() & $TypeMasks::VehicleObjectType && %col.getDamageLevel())
				{
					%col.setDamageLevel(%col.getDamageLevel() - 1);
				
					%health	= 40 - mFloor(40 * %col.getDamagePercent());
					%message	= "<color:00ff00>";
					
					for(%a = 0; %a < 40; %a++)
						if(%a == %health)
							%message = %message @ "<color:ff0000>|";
						else
							%message = %message @ "|";
					
					if(%col.crpgLastMessage[%client.getID()] != %health || $sim::time - %col.crpgLastMessage[%client.getID()] > 1)
					{
						%col.crpgLastHealth[%client.getID()]	= %health;
						%col.crpgLastMessage[%client.getID()]	= $sim::time;
						commandToClient(%client, 'BottomPrint', "<just:center>\c6VEHICLE HEALTH" NL %message, 2);
					}
				}
				else
				{
					if(%col.crpgLastMessage[%client.getID()] != %health || $sim::time - %col.crpgLastMessage[%client.getID()] > 1)
					{
						%col.crpgLastHealth[%client.getID()]	= %health;
						%col.crpgLastMessage[%client.getID()]	= $sim::time;
						commandToClient(%client, 'BottomPrint', "<just:center>\c6VEHICLE HEALTH" NL "<color:00ff00>Completely Repaired", 2);
					}
				}
			
			case 2:
				if(%col.getType() & $TypeMasks::fxBrickObjectType)
				{
					%col.crpgBrickWorked = %obj.getID();
					%col.onWorked(%obj.client);
				}
			
			case 3:
				if(%col.getType() & $TypeMasks::PlayerObjectType)
				{
					%this.onRaycastDamage(%obj, %slot, %col, %pos, %normal, %shotVec, %crit);
				}
		}
	}
	
	return parent::onHitObject(%this, %obj, %slot, %col, %pos, %normal, %shotVec, %crit);
}

function CRPG_Drill_Image::onRaycastDamage(%this, %obj, %slot, %col, %pos, %normal, %shotVec, %crit)
{
	// Player Stunning
	if(%col.getType() & $TypeMasks::PlayerObjectType)
	{
		if(!isObject(%col.client) || !(%col.client.profile.getWantedLevel() || %obj.client.crpgEvil))
			return;
			
		if(!%col.crpgStunned)
		{
			%damageType = $DamageType::Direct;
			if(%this.raycastDirectDamageType)
				%damageType = %this.raycastDirectDamageType;
			
			%scale = getWord(%obj.getScale(), 2);
			%directDamage = mClampF(CRPG_Baton_Image.raycastDirectDamage, -100, 100) * %scale;
			
			if(%this.raycastImpactImpulse > 0)
				%col.applyImpulse(%pos,vectorScale(%shotVec, %this.raycastImpactImpulse));
			
			if(%this.raycastVerticalImpulse > 0)
				%col.applyImpulse(%pos,vectorScale("0 0 1", %this.raycastVerticalImpulse));
			
			if(%directDamage >= %col.getDatablock().maxDamage - %col.getDamageLevel())
				%directDamage = (%col.getDatablock().maxDamage - %col.getDamageLevel()) - 1;
			
			if(%directDamage > 0)
				%col.damage(%obj, %pos, %directDamage, %damageType);
			
			if(%col.getDatablock().maxDamage - %col.getDamageLevel() == 1)
			{
				if(isObject(%obj.client))
					commandToClient(%obj.client, 'CenterPrint', "<just:right>\c2Player Stunned!", 1);
				
				%col.setStunned(10);
			}
		}
		else if(isObject(%obj.client))
		{
			commandToClient(%obj.client, 'CenterPrint', "<just:right>\c2Player Stunned!", 1);
		}
	}
	else
	{
		return parent::onRaycastDamage(%this, %obj, %slot, %col, %pos, %normal, %shotVec, %crit);
	}
}

if(!isObject(CRPG_Drill_Item))
{
	datablock ItemData(CRPG_Drill_Item)
	{
		category		= "Weapon";
		className	= "Weapon";
		
		mass			= 1;
		density		= 0.2;
		elasticity	= 0.2;
		friction		= 0.6;
		emap			= true;
		
		uiName		= "Mechanic's Drill";
		shapeFile	= "base/data/shapes/Hammer.dts";
		iconName		= "base/client/ui/itemIcons/Hammer";
		
		doColorShift		= true;
		colorShiftColor	= "1 1 0 1";
		
		image		= CRPG_Drill_Image;
		canDrop	= false;
	};
}

if(!isObject(CRPG_Drill_Image))
{
	datablock ShapeBaseImageData(CRPG_Drill_Image)
	{
		// Raycast Properties
		raycastWeaponRange				= 128;
		raycastWeaponTargets				= ($TypeMasks::FxBrickObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType);
		raycastWeaponPierceTargets		= 0;
		raycastDirectDamage				= 0;
		raycastDirectDamageType			= 0;
		raycastCritDirectDamageType	= 0;
		raycastExplosionProjectile		= HammerProjectile;
		raycastExplosionSound			= HammerHitSound;
		raycastExplosionPlayerSound	= HammerHitSound;
		raycastExplosionBrickSound		= HammerHitSound;
		raycastSpreadAmt					= 0;	
		raycastSpreadCount				= 1;
		raycastTracerProjectile			= 0;
		raycastFromMuzzle					= false;
		
		// Weapon Modes
		numModes = 4;
		mode[0] = "Repair Mode";
		mode[1] = "Dismember Mode";
		mode[2] = "Factory Mode";
		mode[3] = "Less-Than-Lethal Mode";
		
		shapeFile	= "base/data/shapes/Hammer.dts";
		emap			= true;

		mountPoint	= 0;
		offset		= "0 0 0";
		eyeOffset	= "0.0 0.0 0.0";
		rotation		= eulerToMatrix( "0 0 0" );

		className	= "WeaponImage";
		item			= CRPG_Drill_Item;

		melee			= true;
		armReady		= true;

		doColorShift = true;
		colorShiftColor = CRPG_Drill_Item.colorShiftColor;
		
		stateName[0]							= "Activate";
		stateTimeoutValue[0]					= 0.5;
		stateTransitionOnTimeout[0]		= "Ready";
		
		stateName[1]							= "Ready";
		stateTransitionOnTriggerDown[1]	= "PreFire";
		stateAllowImageChange[1]			= true;
		
		stateName[2]							= "PreFire";
		stateScript[2]							= "onPreFire";
		stateAllowImageChange[2]			= false;
		stateTimeoutValue[2]					= 0.05;
		stateTransitionOnTimeout[2]		= "Fire";
		
		stateName[3]							= "Fire";
		stateTransitionOnTimeout[3]		= "CheckFire";
		stateTimeoutValue[3]					= 0.1;
		stateFire[3]							= true;
		stateAllowImageChange[3]			= false;
		stateSequence[3]						= "Fire";
		stateScript[3]							= "onFire";
		stateWaitForTimeout[3]				= true;
		
		stateName[4]							= "CheckFire";
		stateTransitionOnTriggerUp[4]		= "StopFire";
		stateTransitionOnTriggerDown[4]	= "Fire";
		
		stateName[5]							= "StopFire";
		stateTransitionOnTimeout[5]		= "Ready";
		stateTimeoutValue[5]					= 0.2;
		stateAllowImageChange[5]			= false;
		stateWaitForTimeout[5]				= true;
		stateSequence[5]						= "StopFire";
		stateScript[5]							= "onStopFire";
	};
}

// Handcuff Bondage
function CRPG_Handcuffs_Image::onMount(%this, %obj, %slot)
{
	parent::onMount(%this, %obj, %slot);	
	%obj.playThread(2, "armReadyBoth");
}

function CRPG_Handcuffs_Image::onUnMount(%this, %obj, %slot)
{
	parent::onMount(%this, %obj, %slot);	
	%obj.playThread(2, "root");
}

if(!isObject(CRPG_Handcuffs_Image))
{
	datablock ShapeBaseImageData(CRPG_Handcuffs_Image)
	{
		shapeFile = $CRPG::Path::Shapes @ "Handcuffs_Item.dts";
		emap = true;
		
		mountPoint = 0;
		offset = "0 0 0";
		eyeOffset = "0.0 0.0 0.0";
		rotation = eulerToMatrix( "0 0 0" );
		
		className = "WeaponImage";
		item = CRPG_Handcuffs_Item;
		
		melee = false;
		armReady = true;
		LarmReady = true;
		
		doColorShift = true;
		colorShiftColor = CRPG_Handcuffs_Item.colorShiftColor;
		
		stateName[0]							= "Activate";
		stateTimeoutValue[0]					= 0.5;
		stateTransitionOnTimeout[0]		= "Ready";
		
		stateName[1]							= "Ready";
		stateAllowImageChange[1]			= true;
	};
}

// Handcuff Tool
function CRPG_HandcuffsU_Image::onHitObject(%this, %obj, %slot, %col, %pos, %normal, %shotVec, %crit)
{
	if((isObject(%obj) && %obj.getType() & $TypeMasks::PlayerObjectType) &&
		(isObject(%col) && %col.getType() & $TypeMasks::PlayerObjectType) &&
		!%col.crpgArrested)
	{
		%oc = %obj.client;
		%cc = %col.client;
		
		if(isObject(%oc) && isObject(%cc))
		{
			%op = %oc.profile;
			%cp = %cc.profile;
			%mission = %oc.mission;
			
			if(isObject(%op) && isObject(%cp) && (%cp.getWantedLevel() || %mission.obj_Can_Arrest_Anyone || %oc.crpgEvil))
			{
				%failure = 100;
				
				// Victims' Anarchy
				%failure += %op.getBeliefAnarchy() * 2;
				
				// Cop's Order
				%failure += %cp.getBeliefOrder() * 2;
				
				if(!%mission.obj_Can_Arrest_Anyone)
				{
					// Stun Check
					if(%col.crpgStunned)
						%failure -= 100;
					
					// Crouch Check
					if(%col.isCrouched())
						%failure -= 25;
					
					// Sneak Check
					if(getWord(%col.rotation, 3) - 45 < getWord(%obj.rotation, 3) && getWord(%col.rotation, 3) + 45 > getWord(%obj.rotation, 3))
						%failure -= 30;
					
					// Damage Check
					%failure -= mFloor(%col.getDamagePercent() * 75) >= 30 ? mFloor(%col.getDamagePercent() * 75) : 0;
					
					%failure = mClamp(%failure, 0, %failure);
				}
				else
					%failure = 0;
				
				if(getRandom(0, %failure) < 15)
				{
					serverPlay3d(CRPG_Handcuff_Sound, %pos);
					%cc.arrest(%oc);
					
					if(!%cp.getWantedLevel() && !%mission.obj_Can_Arrest_Anyone)
						%col.crpgFalseArrestClue = %oc.commitCrime("Unwarranted Arrest", 25, false, true, false, false, 60000, "");
				}
				else
				{
					commandToClient(%oc, 'CenterPrint', "<just:right>Resisted Arrest!", 1);
					commandToClient(%cc, 'CenterPrint', "<just:right>Arrest Resisted!", 1);
				}
			}
		}
	}
	
	return parent::onHitObject(%this, %obj, %slot, %col, %pos, %normal, %shotVec, %crit);
}

function CRPG_HandcuffsU_Image::onPreFire(%this, %obj, %slot)
{
	%obj.playThread(2, "wrench");
}

if(!isObject(CRPG_HandcuffsU_Item))
{
	datablock ItemData(CRPG_HandcuffsU_Item)
	{
		category		= "Weapon";
		className	= "Weapon";
		
		mass			= 1;
		density		= 0.2;
		elasticity	= 0.2;
		friction		= 0.6;
		emap			= true;
		
		uiName		= "Handcuffs";
		shapeFile	= $CRPG::Path::Shapes @ "Handcuffs_Item.dts";
		iconName		= $CRPG::Path::Images @ "itemIcons/Icon_Handcuffs";
		
		doColorShift		= true;
		colorShiftColor	= (180/255) SPC (180/255) SPC (180/255) SPC (255/255);
		
		image		= CRPG_HandcuffsU_Image;
		canDrop	= false;
	};
}

if(!isObject(CRPG_HandcuffsU_Image))
{
	datablock ShapeBaseImageData(CRPG_HandcuffsU_Image)
	{
		// Raycast Properties
		raycastWeaponRange				= 6;
		raycastWeaponTargets				= ($TypeMasks::FxBrickObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType);
		raycastWeaponPierceTargets		= 0;
		raycastDirectDamage				= 0;
		raycastDirectDamageType			= 0;
		raycastCritDirectDamageType	= 0;
		raycastExplosionProjectile		= HammerProjectile;
		raycastExplosionSound			= 0;
		raycastExplosionPlayerSound	= 0;
		raycastExplosionBrickSound		= 0;
		raycastSpreadAmt					= 0;	
		raycastSpreadCount				= 1;
		raycastTracerProjectile			= 0;
		raycastFromMuzzle					= false;
		
		shapeFile	= $CRPG::Path::Shapes @ "Handcuffs.dts";
		emap			= true;

		mountPoint	= 0;
		offset		= "0 0 0";
		eyeOffset	= "0.0 0.0 0.0";
		rotation		= eulerToMatrix( "0 0 0" );

		className	= "WeaponImage";
		item			= CRPG_HandcuffsU_Item;

		melee			= true;
		armReady		= true;

		doColorShift = true;
		colorShiftColor = CRPG_HandcuffsU_Item.colorShiftColor;
		
		stateName[0]							= "Activate";
		stateTimeoutValue[0]					= 0.5;
		stateTransitionOnTimeout[0]		= "Ready";
		
		stateName[1]							= "Ready";
		stateTransitionOnTriggerDown[1]	= "PreFire";
		stateAllowImageChange[1]			= true;
		
		stateName[2]							= "PreFire";
		stateScript[2]							= "onPreFire";
		stateAllowImageChange[2]			= false;
		stateTimeoutValue[2]					= 0.25;
		stateTransitionOnTimeout[2]		= "Fire";
		
		stateName[3]							= "Fire";
		stateTransitionOnTimeout[3]		= "CheckFire";
		stateTimeoutValue[3]					= 0.5;
		stateFire[3]							= true;
		stateAllowImageChange[3]			= false;
		stateSequence[3]						= "Fire";
		stateScript[3]							= "onFire";
		stateWaitForTimeout[3]				= true;
		
		stateName[4]							= "CheckFire";
		stateTransitionOnTriggerUp[4]		= "StopFire";
		
		stateName[5]							= "StopFire";
		stateTransitionOnTimeout[5]		= "Ready";
		stateTimeoutValue[5]					= 0.2;
		stateAllowImageChange[5]			= false;
		stateWaitForTimeout[5]				= true;
		stateSequence[5]						= "StopFire";
		stateScript[5]							= "onStopFire";
	};
}

// Hat
if(!isObject(CRPG_Hat_Mayor_Item))
{
	datablock ItemData(CRPG_Hat_Mayor_Item)
	{
		category = "Weapon";  // Mission editor category
		className = "Weapon"; // For inventory system
		
		 // Basic Item Properties
		shapeFile = $CRPG::Path::Shapes @ "Hat_Mayor.dts";
		rotate = false;
		mass = 1;
		density = 0.2;
		elasticity = 0.2;
		friction = 0.6;
		emap = true;
		
		//gui stuff
		uiName = "Top Hat";
		iconName = $CRPG::Path::Images @ "itemIcons/Icon_TopHat";
		doColorShift = false;
		
		 // Dynamic properties defined by the scripts
		image = CRPG_Hat_Mayor_Image;
		canDrop = true;
		handsFree = true;
	};
}

if(!isObject(CRPG_Hat_Mayor_Image))
{
	datablock ShapeBaseImageData(CRPG_Hat_Mayor_Image)
	{
		shapeFile = $CRPG::Path::Shapes @ "Hat_Mayor.dts";
		item = CRPG_Hat_Mayor_Item;
		emap = true;
		firstPerson = false;
		mountPoint = $HeadSlot;
		offset = "0 -0.010 0.110";
		eyeOffset = "0 0 10";
		
		stateName[0]						= "Ready";
	};
}

function CRPG_Hat_Mayor_Item::onPickup(%this, %item, %obj, %slot)
{
	%obj.mountImage(%this.image, $BackSlot);
	return parent::onPickup(%this, %item, %obj, %slot);
}

function CRPG_Hat_Mayor_Item::onUse(%this, %obj, %slot)
{
	%obj.unMountImage(0);
	%obj.playThread(0, root);
	%obj.playThread(1, root);
}

// Lumberjack
function CRPG_Lumberjack_Image::onPreFire(%this, %obj, %slot)
{
	%obj.playThread(2, "armAttack");
}

function CRPG_Lumberjack_Image::onStopFire(%this, %obj, %slot)
{
	%obj.playThread(2, "root");
}

function CRPG_Lumberjack_Image::onHitObject(%this, %obj, %slot, %col, %pos, %normal, %shotVec, %crit)
{
	parent::onHitObject(%this, %obj, %slot, %col, %pos, %normal, %shotVec, %crit);
	
	if(isObject(%obj.client) && isObject(%col) && (%col.getType() & $TypeMasks::fxBrickObjectType))
		%col.getDatablock().onChop(%col, %obj.client);
}

if(!isObject(CRPG_Lumberjack_Item))
{
	datablock itemData(CRPG_Lumberjack_Item)
	{
		category		= "Weapon";
		className	= "Weapon";
		
		mass			= 1;
		density		= 0.2;
		elasticity	= 0.2;
		friction		= 0.6;
		emap			= true;
		
		uiName		= "Lumberjack Axe";
		shapeFile	= $CRPG::Path::Shapes @ "Axe.dts";
		iconName		= $CRPG::Path::Images @ "itemIcons/Icon_Axe";
		
		doColorShift		= true;
		colorShiftColor	= (180/255) SPC (180/255) SPC (180/255) SPC (255/255);
		
		image		= CRPG_Lumberjack_Image;
		canDrop	= false;
		
	};
}

if(!isObject(CRPG_Lumberjack_Image))
{
	datablock shapeBaseImageData(CRPG_Lumberjack_Image)
	{
		// SpaceCasts
		raycastWeaponRange				= 6;
		raycastWeaponTargets				= ($TypeMasks::FxBrickObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType);
		raycastWeaponPierceTargets		= 0;
		raycastDirectDamage				= 0;
		raycastDirectDamageType			= $DamageType::CRPGAxe;
		raycastCritDirectDamageType	= $DamageType::CRPGAxe;
		raycastExplosionProjectile		= CRPG_Baton_Projectile;
		raycastExplosionSound			= CRPG_Wood_Hit_Sound;
		raycastExplosionPlayerSound	= CRPG_Wood_Hit_Sound;
		raycastExplosionBrickSound		= CRPG_Wood_Hit_Sound;
		raycastSpreadAmt					= 0;
		raycastSpreadCount				= 0;
		raycastTracerProjectile			= -1;
		raycastFromMuzzle					= false;
		
		projectile = hammerProjectile;
		armReady = true;
		melee = true;
		eyeOffset = "0 0 0";
		offset = "0 0 0.45";
		
		shapeFile = $CRPG::Path::Shapes @ "Axe.dts";
		emap = true;
		
		mountPoint = 0;
		offset = "0 0 0.45";
		 
		correctMuzzleVector = false;
		
		eyeOffset = "0 0 0";
		className = "WeaponImage";
		
		item = CRPG_Lumberjack_Item;
		ammo = " ";
		projectile = hammerProjectile;
		projectileType = Projectile;
		
		melee = true;
		doRetraction = false;
		armReady = true;
		
		doColorShift = true;
		colorShiftColor = "0.471 0.471 0.471 1.000";
		
		stateName[0]							= "Activate";
		stateTransitionOnTimeout[0]		= "Ready";
		
		stateName[1]							= "Ready";
		stateTransitionOnTriggerDown[1]	= "PreFire";
		stateAllowImageChange[1]			= true;
		
		stateName[2]							= "PreFire";
		stateScript[2]							= "onPreFire";
		stateAllowImageChange[2]			= false;
		stateTimeoutValue[2]					= 0.1;
		stateTransitionOnTimeout[2]		= "Fire";
		
		stateName[3]							= "Fire";
		stateTransitionOnTimeout[3]		= "CheckFire";
		stateTimeoutValue[3]					= 0.2;
		stateFire[3]							= true;
		stateAllowImageChange[3]			= false;
		stateSequence[3]						= "Fire";
		stateScript[3]							= "onFire";
		stateWaitForTimeout[3]				= true;
		
		stateName[4]							= "CheckFire";
		stateTransitionOnTriggerUp[4]		= "StopFire";
		stateTransitionOnTriggerDown[4]	= "Fire";
		
		stateName[5]							= "StopFire";
		stateTransitionOnTimeout[5]		= "Ready";
		stateTimeoutValue[5]					= 0.2;
		stateAllowImageChange[5]			= false;
		stateWaitForTimeout[5]				= true;
		stateSequence[5]						= "StopFire";
		stateScript[5]							= "onStopFire";
	};
}

// Key
function CRPG_Key_Image::onFire(%this, %obj, %slot)
{
	%start	= %obj.getEyePoint();
	%vec		= vectorScale(%obj.getMuzzleVector(%slot), 10  * getWord(%obj.getScale(), 2));
	%end		= vectorAdd(%start, %vec);
	%mask		= $CRPG::ShootMasks;
	
	%rayCast	= containerRayCast(%start, %end, %mask, %obj);

	if(!%rayCast)
		return;
	
	%col = getWord(%rayCast, 0);
	%hitPos = getWords(%rayCast, 1, 3);
	%hitNormal = getWords(%rayCast, 4, 6);

	%this.onHitObject(%obj, %slot, %col, %hitPos, %hitNormal);	
}

function CRPG_Key_Image::onHitObject(%this, %obj, %slot, %col, %hitPos, %hitNormal)
{
	%client = %obj.client;
	
	if(isObject(%client))
	{
		%profile = %client.profile;
		
		if(isObject(%profile))
		{
			if(%col.getType() & $TypeMasks::VehicleObjectType)
			{
				if(!%col.getAbsVelocity() && !%col.getMountedObjectCount())
				{
					%brickGroup = %col.brickGroup;
					
					if(isObject(%brickGroup))
					{
						%owner = %brickGroup.name;
						
						if(getTrustLevel(%obj, %col) >= 2)
						{
							%col.crpgLocked = !%col.crpgLocked;
							%col.disableMove = %col.crpgLocked;
							
							%lastChar = getSubStr(%owner, strLen(%owner) - 1, 1);
							%owner = %owner @ "\'" @ (lastChar $= "s" || %lastChar $= "z" ? "" : "s");
							
							commandToClient(%client, 'CenterPrint', "\c3" @ %owner @ "\c6 vehicle is now \c3" @ (%col.crpgLocked ? "Locked" : "Unlocked") @ "\c6.", 2);
						}
						else
						{
							commandToClient(%client, 'CenterPrint', "\c3" @ %owner @ "\c6 does not trust you enough to do that.", 2);
						}
					}
					else
					{
						commandToClient(%client, 'CenterPrint', "\c6This vehicle has no owner and cannot be locked.", 2);
					}
				}
			}
		}
	}
}

function CRPG_Key_Image::onPreFire(%this, %obj, %slot)
{
	%obj.playThread(2, "shiftLeft");
}

function CRPG_Key_Image::onStopFire(%this, %obj, %slot)
{	
	%obj.playThread(2, "root");
}

datablock ItemData(CRPG_Key_Item)
{
	 // Basic Item Properties
	shapeFile = "Add-Ons/Item_Key/keyB.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui properties
	uiName = "Car Key";
	iconName = "Add-Ons/Item_Key/Icon_KeyB";
	doColorShift = true;
	colorShiftColor = "1.0 1.0 0.0 1.0";

	 // Dynamic properties defined by the scripts
	image = CRPG_Key_Image;
	canDrop = true;
};

datablock ShapeBaseImageData(CRPG_Key_Image)
{
	// Basic Item properties
	shapeFile = "Add-Ons/Item_Key/keyB.dts";
	emap = true;

	// Specify mount point & offset for 3rd person, and eye offset
	// for first person rendering.
	mountPoint = 0;
	offset = "0 0 0";

	// When firing from a point offset from the eye, muzzle correction
	// will adjust the muzzle vector to point to the eye LOS point.
	// Since this weapon doesn't actually fire from the muzzle point,
	// we need to turn this off.  
	correctMuzzleVector = false;

	// Add the WeaponImage namespace as a parent, WeaponImage namespace
	// provides some hooks into the inventory system.
	className = "WeaponImage";

	// Projectile && Ammo.
	item = CRPG_Key_Item;
	ammo = " ";
	projectile = "";
	projectileType = "";

	//melee particles shoot from eye node for consistancy
	melee = true;
	doRetraction = false;
	//raise your arm up or not
	armReady = true;

	showBricks = false;

	//casing = " ";

	doColorShift = true;
	colorShiftColor = CRPG_Key_Item.colorShiftColor;

	// Images have a state system which controls how the animations
	// are run, which sounds are played, script callbacks, etc. This
	// state system is downloaded to the client so that clients can
	// predict state changes and animate accordingly.  The following
	// system supports basic ready->fire->reload transitions as
	// well as a no-ammo->dryfire idle state.

	// Initial start up state
	stateName[0]							= "Activate";
	stateTimeoutValue[0]				 = 0.0;
	stateTransitionOnTimeout[0]		= "Ready";

	stateName[1]							= "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]			= true;

	stateName[2]						  = "PreFire";
	stateScript[2]						= "onPreFire";
	stateAllowImageChange[2]		  = true;
	stateTimeoutValue[2]				= 0.01;
	stateTransitionOnTimeout[2]	  = "Fire";

	stateName[3]						  = "Fire";
	stateTransitionOnTimeout[3]	  = "CheckFire";
	stateTimeoutValue[3]				= 0.15;
	stateFire[3]						  = true;
	stateAllowImageChange[3]		  = true;
	stateSequence[3]					 = "Fire";
	stateScript[3]						= "onFire";
	stateWaitForTimeout[3]			  = true;
	stateSequence[3]					 = "Fire";

	stateName[4]						  = "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";

	stateName[5]						  = "StopFire";
	stateTransitionOnTimeout[5]	  = "Ready";
	stateTimeoutValue[5]				= 0.01;
	stateAllowImageChange[5]		  = true;
	stateWaitForTimeout[5]			 = true;
	stateSequence[5]					 = "StopFire";
	stateScript[5]						= "onStopFire";
};

// Mangifying Glass
function CRPG_Magnify_Image::onFire(%this, %obj, %slot)
{
	%client = %obj.client;
	
	if(isObject(%client) && isObject(%profile = %client.profile))
	{
		if(%obj.getEnergyLevel() >= 75)
		{
			%obj.setEnergyLevel(%obj.getEnergyLevel() - 75);
			%obj.playThread(2, "shiftDown");
			%obj.spawnExplosion(CRPG_Magnify_Projectile, 1);
			
			initContainerRadiusSearch(%obj.getPosition(), 24, $TypeMasks::ItemObjectType);
			
			while(isObject(%col = containerSearchNext()))
			{
				if(%col.getDatablock().getID() == CRPG_Clue_Hidden_Item.getID())
				{
					%start	= %obj.getEyePoint();
					%end		= %col.getWorldBoxCenter();
					%masks	= ($TypeMasks::FxBrickObjectType | $TypeMasks::ItemObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType);
					%hit		= getWord(containerRayCast(%start, %end, %masks, %obj), 0);
					
					// Object matches our clue, and we aren't responsible for it.
					if(isObject(%hit) && %col.getID() == %hit.getID() && %hit.clueBLID != %client.bl_id)
					{
						%col.setDatablock(CRPG_Clue_Item);
						%col.clueHidden = false;
					}
				}
			}
		}
		else
		{
			commandToClient(%client, 'CenterPrint', "\c6You are too tired to search for clues.\n\c6Please wait for your energy bar to fill.", 2);
		}
	}
}

if(!isObject(CRPG_Magnify_Item))
{
	datablock ItemData(CRPG_Magnify_Item)
	{
		category		= "Weapon";
		className	= "Weapon";
		
		mass			= 1;
		density		= 0.2;
		elasticity	= 0.2;
		friction		= 0.6;
		emap			= true;
		
		uiName		= "Magnifying Glass";
		shapeFile	= $CRPG::Path::Shapes @ "Magnifying_Glass.dts";
		iconName		= $CRPG::Path::Images @ "itemIcons/Icon_Magnifying_Glass";
		
		doColorShift		= true;
		colorShiftColor	= "1 1 1 1";
		
		image		= CRPG_Magnify_Image;
		canDrop	= false;
	};
}

if(!isObject(CRPG_Magnify_Image))
{
	datablock ShapeBaseImageData(CRPG_Magnify_Image)
	{
		shapeFile	= $CRPG::Path::Shapes @ "Magnifying_Glass.dts";
		emap			= true;

		mountPoint	= 0;
		offset		= "0 0 0";
		eyeOffset	= "0.0 0.0 0.0";
		rotation		= eulerToMatrix( "0 0 0" );

		className	= "WeaponImage";
		item			= CRPG_Magnify_Item;

		melee			= true;
		armReady		= true;

		doColorShift = true;
		colorShiftColor = CRPG_Magnify_Item.colorShiftColor;
		
		stateName[0]							= "Activate";
		stateTimeoutValue[0]					= 0.5;
		stateTransitionOnTimeout[0]		= "Ready";
		
		stateName[1]							= "Ready";
		stateTransitionOnTriggerDown[1]	= "PreFire";
		stateAllowImageChange[1]			= true;
		
		stateName[2]							= "PreFire";
		stateScript[2]							= "onPreFire";
		stateAllowImageChange[2]			= false;
		stateTimeoutValue[2]					= 0.25;
		stateTransitionOnTimeout[2]		= "Fire";
		
		stateName[3]							= "Fire";
		stateTransitionOnTimeout[3]		= "CheckFire";
		stateTimeoutValue[3]					= 0.5;
		stateFire[3]							= true;
		stateAllowImageChange[3]			= false;
		stateSequence[3]						= "Fire";
		stateScript[3]							= "onFire";
		stateWaitForTimeout[3]				= true;
		
		stateName[4]							= "CheckFire";
		stateTransitionOnTriggerUp[4]		= "StopFire";
		
		stateName[5]							= "StopFire";
		stateTransitionOnTimeout[5]		= "Ready";
		stateTimeoutValue[5]					= 0.2;
		stateAllowImageChange[5]			= false;
		stateWaitForTimeout[5]				= true;
		stateSequence[5]						= "StopFire";
		stateScript[5]							= "onStopFire";
	};
}

// Pickaxe
function CRPG_Pickaxe_Image::onPreFire(%this, %obj, %slot)
{
	%obj.playThread(2, "armAttack");
}

function CRPG_Pickaxe_Image::onStopFire(%this, %obj, %slot)
{
	%obj.playThread(2, "root");
}

function CRPG_Pickaxe_Image::onHitObject(%this, %obj, %slot, %col, %pos, %normal, %shotVec, %crit)
{
	parent::onHitObject(%this, %obj, %slot, %col, %pos, %normal, %shotVec, %crit);
	
	if(isObject(%obj.client) && isObject(%col) && (%col.getType() & $TypeMasks::fxBrickObjectType))
		%col.getDatablock().onMine(%col, %obj.client);
}

if(!isObject(CRPG_Pickaxe_Item))
{
	datablock itemData(CRPG_Pickaxe_Item)
	{
		category		= "Weapon";
		className	= "Weapon";
		
		mass			= 1;
		density		= 0.2;
		elasticity	= 0.2;
		friction		= 0.6;
		emap			= true;
		
		uiName		= "Pickaxe";
		shapeFile	= $CRPG::Path::Shapes @ "Pickaxe.dts";
		iconName		= $CRPG::Path::Images @ "itemIcons/Icon_Pickaxe";
		
		doColorShift		= true;
		colorShiftColor	= "0.150 0.150 0.150 1.000";
		
		image		= CRPG_Pickaxe_Image;
		canDrop	= false;
	};
}

if(!isObject(CRPG_Pickaxe_Image))
{
	datablock shapeBaseImageData(CRPG_Pickaxe_Image)
	{
		// SpaceCasts
		raycastWeaponRange				= 6;
		raycastWeaponTargets				= ($TypeMasks::FxBrickObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType);
		raycastWeaponPierceTargets		= 0;
		raycastDirectDamage				= 0;
		raycastDirectDamageType			= $DamageType::CRPGPickaxe;
		raycastCritDirectDamageType	= $DamageType::CRPGPickaxe;
		raycastExplosionProjectile		= CRPG_Pickaxe_Projectile;
		raycastExplosionSound			= CRPG_Metal_Hit_Sound;
		raycastExplosionPlayerSound	= CRPG_Metal_Hit_Sound;
		raycastExplosionBrickSound		= CRPG_Metal_Hit_Sound;
		raycastSpreadAmt					= 0;
		raycastSpreadCount				= 0;
		raycastTracerProjectile			= -1;
		raycastFromMuzzle					= false;
		
		projectile = hammerProjectile;
		armReady = true;
		melee = true;
		eyeOffset = "0 0 0";
		offset = "0 0 0.45";
		
		shapeFile = $CRPG::Path::Shapes @ "Pickaxe.dts";
		emap = true;
		
		mountPoint = 0;
		offset = "0 0 0.45";
		 
		correctMuzzleVector = false;
		
		eyeOffset = "0 0 0";
		className = "WeaponImage";
		
		item = CRPG_Lumberjack_Item;
		ammo = " ";
		projectile = hammerProjectile;
		projectileType = Projectile;
		
		melee = true;
		doRetraction = false;
		armReady = true;
		
		doColorShift = true;
		colorShiftColor = "0.150 0.150 0.150 1.000";
		
		stateName[0]							= "Activate";
		stateTransitionOnTimeout[0]		= "Ready";
		
		stateName[1]							= "Ready";
		stateTransitionOnTriggerDown[1]	= "PreFire";
		stateAllowImageChange[1]			= true;
		
		stateName[2]							= "PreFire";
		stateScript[2]							= "onPreFire";
		stateAllowImageChange[2]			= false;
		stateTimeoutValue[2]					= 0.1;
		stateTransitionOnTimeout[2]		= "Fire";
		
		stateName[3]							= "Fire";
		stateTransitionOnTimeout[3]		= "CheckFire";
		stateTimeoutValue[3]					= 0.2;
		stateFire[3]							= true;
		stateAllowImageChange[3]			= false;
		stateSequence[3]						= "Fire";
		stateScript[3]							= "onFire";
		stateWaitForTimeout[3]				= true;
		
		stateName[4]							= "CheckFire";
		stateTransitionOnTriggerUp[4]		= "StopFire";
		stateTransitionOnTriggerDown[4]	= "Fire";
		
		stateName[5]							= "StopFire";
		stateTransitionOnTimeout[5]		= "Ready";
		stateTimeoutValue[5]					= 0.2;
		stateAllowImageChange[5]			= false;
		stateWaitForTimeout[5]				= true;
		stateSequence[5]						= "StopFire";
		stateScript[5]							= "onStopFire";
	};
}

// Spanner
function CRPG_Spanner_Image::onPreFire(%this, %obj, %slot)
{
	%obj.playThread(2, "wrench");
}

function CRPG_Spanner_Image::onStopFire(%this, %obj, %slot)
{
	%obj.playThread(2, "root");
}

function CRPG_Spanner_Image::onHitObject(%this, %obj, %slot, %col, %pos, %normal, %shotVec, %crit)
{
	if(isObject(%this.raycastExplosionProjectile))
	{
		%scaleFactor = getWord(%obj.getScale(), 2);
		%p = new Projectile()
		{
			dataBlock = %this.raycastExplosionProjectile;
			initialPosition = %pos;
			initialVelocity = %normal;
			sourceObject = %obj;
			client = %obj.client;
			sourceSlot = 0;
			originPoint = %pos;
		};
		MissionCleanup.add(%p);
		%p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);
		%p.explode();
	}
	
	if(%col.numEvents)
		serverPlay3d(%this.raycastExplosionBrickSound, %pos);
	else
		serverPlay3d(%this.raycastExplosionSound, %pos);
	
	if(isObject(%obj.client) && isObject(%col) && (%col.getType() & $TypeMasks::fxBrickObjectType))
	{
		%col.crpgBrickWorked = %obj.getID();
		%col.onWorked(%obj.client);
	}
}

if(!isObject(CRPG_Spanner_Item))
{
	datablock itemData(CRPG_Spanner_Item)
	{
		category		= "Weapon";
		className	= "Weapon";
		
		mass			= 1;
		density		= 0.2;
		elasticity	= 0.2;
		friction		= 0.6;
		emap			= true;
		
		uiName		= "Spanner";
		shapeFile	= "base/data/shapes/wrench.dts";
		iconName		= "base/client/ui/itemIcons/Wrench";
		
		doColorShift		= true;
		colorShiftColor	= "0.150 0.150 0.150 1.000";
		
		image		= CRPG_Spanner_Image;
		canDrop	= false;
	};
}

if(!isObject(CRPG_Spanner_Image))
{
	datablock shapeBaseImageData(CRPG_Spanner_Image)
	{
		// SpaceCasts
		raycastWeaponRange				= 6;
		raycastWeaponTargets				= ($TypeMasks::FxBrickObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType);
		raycastWeaponPierceTargets		= 0;
		raycastDirectDamage				= 0;
		raycastDirectDamageType			= $DamageType::Direct;
		raycastCritDirectDamageType	= $DamageType::Direct;
		raycastExplosionProjectile		= wrenchProjectile;
		raycastExplosionSound			= wrenchMissSound;
		raycastExplosionPlayerSound	= 0;
		raycastExplosionBrickSound		= wrenchHitSound;
		raycastSpreadAmt					= 0;
		raycastSpreadCount				= 0;
		raycastTracerProjectile			= -1;
		raycastFromMuzzle					= false;
		
		projectile = hammerProjectile;
		armReady = true;
		melee = true;
		eyeOffset = "0 0 0";
		offset = "0 0 0";
		
		shapeFile = "base/data/shapes/wrench.dts";
		emap = true;
		
		mountPoint = 0;
		offset = "0 0 0";
		 
		correctMuzzleVector = false;
		
		eyeOffset = "0 0 0";
		className = "WeaponImage";
		
		item = CRPG_Lumberjack_Item;
		ammo = " ";
		projectile = hammerProjectile;
		projectileType = Projectile;
		
		melee = true;
		doRetraction = false;
		armReady = true;
		
		doColorShift = true;
		colorShiftColor = "0.150 0.150 0.150 1.000";
		
		stateName[0]							= "Activate";
		stateTransitionOnTimeout[0]		= "Ready";
		
		stateName[1]							= "Ready";
		stateTransitionOnTriggerDown[1]	= "PreFire";
		stateAllowImageChange[1]			= true;
		
		stateName[2]							= "PreFire";
		stateScript[2]							= "onPreFire";
		stateAllowImageChange[2]			= false;
		stateTimeoutValue[2]					= 0.01;
		stateTransitionOnTimeout[2]		= "Fire";
		
		stateName[3]							= "Fire";
		stateTransitionOnTimeout[3]		= "CheckFire";
		stateTimeoutValue[3]					= 0.5;
		stateFire[3]							= true;
		stateAllowImageChange[3]			= false;
		stateSequence[3]						= "Fire";
		stateScript[3]							= "onFire";
		stateWaitForTimeout[3]				= true;
		
		stateName[4]							= "CheckFire";
		stateTimeoutValue[4]					= 0.25;
		stateTransitionOnTriggerUp[4]		= "StopFire";
		stateTransitionOnTriggerDown[4]	= "PreFire";
		
		stateName[5]							= "StopFire";
		stateTransitionOnTimeout[5]		= "Ready";
		stateTimeoutValue[5]					= 0.2;
		stateAllowImageChange[5]			= false;
		stateWaitForTimeout[5]				= true;
		stateSequence[5]						= "StopFire";
		stateScript[5]							= "onStopFire";
	};
}

// ============================================================
// Section 6 : Pick-ups
// ============================================================

// Cash
function CRPG_Cash_Item::onAdd(%this, %obj)
{
	parent::onAdd(%this, %obj);
	%obj.schedule(60000, "schedulePop");
}

if(!isObject(CRPG_Cash_Item))
{
	datablock ItemData(CRPG_Cash_Item)
	{
		category				= "Pickup";
		className			= "Pickup";
		
		shapeFile = $CRPG::Path::Shapes @ "Money_Brick.dts";
		mass = 1;
		density = 0.2;
		elasticity = 0.2;
		friction = 0.6;
		emap = true;
		
		doColorShift = true;
		colorShiftColor = "0 0.6 0 1";
		image = CRPG_Cash_Image;
		candrop = true;
		canPickup = false;
	};
}

if(!isObject(CRPG_Cash_Image))
{
	datablock ShapeBaseImageData(CRPG_Cash_Image)
	{
		shapeFile = $CRPG::Path::Shapes @ "Money_Brick.dts";
		emap = true;
		
		doColorShift = true;
		colorShiftColor = CRPG_Cash_Item.colorShiftColor;
		canPickup = false;
	};
}

// Plastic & Gems
if(!isObject(CRPG_Plastic_1_Item))
{
	datablock ItemData(CRPG_Plastic_1_Item)
	{
		category				= "Pickup";
		className			= "Pickup";
		
		mass					= 1;
		density				= 0.2;
		elasticity			= 0.2;
		friction				= 0.6;
		emap					= true;
		
		uiName				= "";
		shapeFile			= $CRPG::Path::Shapes @ "Chunk_1.dts";
		image					= "";
		canDrop				= false;
		
		doColorShift		= true;
		colorShiftColor	= "1 0 1 1";
	};
}

if(!isObject(CRPG_Plastic_2_Item))
{
	datablock ItemData(CRPG_Plastic_2_Item)
	{
		category				= "Pickup";
		className			= "Pickup";
		
		mass					= 1;
		density				= 0.2;
		elasticity			= 0.2;
		friction				= 0.6;
		emap					= true;
		
		uiName				= "";
		shapeFile			= $CRPG::Path::Shapes @ "Chunk_2.dts";
		image					= "";
		canDrop				= false;
		
		doColorShift		= true;
		colorShiftColor	= "1 0 1 1";
	};
}

if(!isObject(CRPG_Plastic_3_Item))
{
	datablock ItemData(CRPG_Plastic_3_Item)
	{
		category				= "Pickup";
		className			= "Pickup";
		
		mass					= 1;
		density				= 0.2;
		elasticity			= 0.2;
		friction				= 0.6;
		emap					= true;
		
		uiName				= "";
		shapeFile			= $CRPG::Path::Shapes @ "Chunk_3.dts";
		image					= "";
		canDrop				= false;
		
		doColorShift		= true;
		colorShiftColor	= "1 0 1 1";
	};
}

if(!isObject(CRPG_Gem_Item))
{
	datablock ItemData(CRPG_Gem_Item)
	{
		category				= "Pickup";
		className			= "Pickup";
		
		mass					= 1;
		density				= 0.2;
		elasticity			= 0.2;
		friction				= 0.6;
		emap					= true;
		
		uiName				= "";
		shapeFile			= "base/data/shapes/Hammer.dts";
		image					= "";
		canDrop				= false;
		
		doColorShift		= true;
		colorShiftColor	= "1 0 0 1";
	};
}

// Clue
function Clue::onAdd(%this, %obj)
{
	echo("Bingo!" SPC %this.getName());
	
	%obj.clueGroup = "";
	%obj.playThread(0, "spin");
	
	SystemSO.crimes++;
	SystemSO.unsolved++;
	
	return parent::onAdd(%this, %obj);
}

if(!isObject(CRPG_Clue_Item))
{
	datablock ItemData(CRPG_Clue_Item)
	{
		category				= "Clue";
		className			= "Clue";
		
		mass					= 1;
		density				= 0.2;
		elasticity			= 0.2;
		friction				= 0.6;
		emap					= true;
		
		uiName				= "";
		shapeFile			= $CRPG::Path::Shapes @ "Clue.dts";
		iconName				= "";
		image					= "";
		canDrop				= false;
		
		doColorShift		= true;
		colorShiftColor	= "1.0 1.0 1.0 1.0";
		
		lightColor			= "0.75 0.0 0.0";
		lightRadius			= 4;
		lightTime			= 250;
		lightType			= "PulsingLight";
	};
}

if(!isObject(CRPG_Clue_Hidden_Item))
{
	datablock ItemData(CRPG_Clue_Hidden_Item)
	{
		category				= "Clue";
		className			= "Clue";
		
		mass					= 1;
		density				= 0.2;
		elasticity			= 0.2;
		friction				= 0.6;
		emap					= true;
		
		uiName				= "";
		//shapeFile			= $CRPG::Path::Shapes @ "Clue.dts";
		shapeFile			= "base/data/shapes/empty.dts";
		iconName				= "";
		image					= "";
		canDrop				= false;
		
		doColorShift		= true;
		colorShiftColor	= "0 0 0 0";
	};
}

// Crate
function CRPG_Crate_Item::onAdd(%this, %obj)
{
	CrateSS.add(%obj);
}

function CRPG_Crate_Image::onMount(%this, %obj, %slot)
{
	%obj.playThread(2, "armReadyBoth");
	parent::onMount(%this, %obj, %slot);
}

function CRPG_Crate_Image::onUnMount(%this, %obj, %slot)
{
	if(!isObject(%obj.getMountedImage(%slot)))
		%obj.playThread(2, "root");
	
	parent::onUnMount(%this, %obj, %slot);
	
	if(!%obj.crpgCrateDumped)
	{
		%crate = new Item()
		{
			datablock	= CRPG_Crate_Item;
			canPickup	= false;
			doReturn		= true;
			dropClient	= %obj.client;
			dropTime		= $sim::time;
			isBig			= true;
			
			isCrate		= true;
			crpgOwner	= (%obj.crpgCrateOwner ? %obj.crpgCrateOwner : %obj.client.bl_id);
			crpgPlastic	= %obj.crpgCratePlastic;
			crpgRefPlastic	= %obj.crpgCrateRefPlastic;
			crpgWorth	= %obj.crpgCrateWorth;
			crpgMission = %obj.crpgCrateMission;
		};
		MissionCleanup.add(%crate);
		
		%crate.canPickup = false;
		%crate.setTransform(vectorAdd(%obj.getEyePoint(), vectorScale(%obj.getAimVector(), 2)) SPC %obj.rotation);
		%crate.setVelocity(vectorAdd(%obj.getVelocity(), VectorScale(%obj.getAimVector(), 15)));
		
		if(%crate.crpgOwner != -1)
		{
			%cclient = findClientByBL_ID(%crate.crpgOwner);
			
			if(isObject(%cclient))
				%name = %cclient.name @ "'s Crate";
			else
				%name = %obj.crpgOwner @  "'s Crate";
		}
		else
		{
			%cclient = findClientByBL_ID(%obj.crpgCrateMission.profile.bl_id);
			
			if(isObject(%cclient))
				%name = %cclient.name @ "'s Mission Crate";
			else
				%name = %obj.crpgCrateMission @  "'s Mission Crate";
		}
		
		
		%crate.setShapeName(%name);
	}
	
	%obj.crpgCrateOwner = "";
	%obj.crpgCrateDumped = "";
	%obj.crpgCratePlastic = "";
	%obj.crpgCrateRefPlastic = "";
	%obj.crpgCrateWorth = "";
	%obj.crpgCrateMission = "";
}

function CRPG_Crate_Image::onUse(%this, %obj, %slot)
{
	%obj.unMountImage(%slot);
}

if(!isObject(CRPG_Crate_Item))
{
	datablock ItemData(CRPG_Crate_Item)
	{
		category				= "Pickup";
		className			= "Pickup";
		
		shapeFile = $CRPG::Path::Shapes @ "Crate.dts";
		rotate = false;
		mass = 1;
		density = 0.2;
		elasticity = 0.2;
		friction = 0.6;
		emap = true;
		
		uiName = "";
		doColorShift = false;
		
		image = CRPG_Crate_Image;
		canDrop = true;
	};
}

if(!isObject(CRPG_Crate_Image))
{
	datablock ShapeBaseImageData(CRPG_Crate_Image)
	{
		isHeavy = true;
		
		shapeFile = $CRPG::Path::Shapes @ "Crate.dts";
		emap = true;
		mountPoint = 0;
		offset = "0 0 0";
		eyeOffset = 0;
		rotation = eulerToMatrix("0 0 0");
		
		className = "WeaponImage";
		item = CRPG_Crate_Item;
		
		armReady = true;
		doColorShift = false;
		
		stateName[0]							= "Activate";
		stateSound[0]							= weaponSwitchSound;
		stateTimeoutValue[0]					= 0.15;
		stateSequence[0]						= "Ready";
		stateTransitionOnTimeout[0]		= "Ready";

		stateName[1]							= "Ready";
		stateAllowImageChange[1]			= true;
		stateScript[1]							= "onReady";
		stateTransitionOnTriggerDown[1]	= "Use";
		
		stateName[2]							= "Use";
		stateScript[2]							= "onUse";
		stateTransitionOnTriggerUp[2]		= "Ready";
	};
}

// ============================================================
// Section 7 : Players
// ============================================================
if(!isObject(CRPG_Civilian_Armor))
{
	datablock PlayerData(CRPG_Civilian_Armor : PlayerStandardArmor)
	{
		// Standard Properties
		canJet			= false;
		canRide			= true;
		jetEnergyDrain	= 0;
		maxDamage		= 100;
		maxEnergy		= 100;
		maxTools			= 10;
		maxWeapons		= 10;
		minJetEnergy	= 0;
		paintable		= true;
		uiName			= "";
		rechargeRate	= 0.5;
		rideAble			= false;
		showEnergyBar	= true;
		
		// Speed Properties
		runEnergyDrain		= 0;
		runForce				= 48 * 90;
		maxBackwardSpeed	= 4 + 0;
		maxForwardSpeed	= 7 + 0;
		maxSideSpeed		= 6 + 0;
		minRunEnergy		= 0;
		
		maxBackwardCrouchSpeed	= 2 + 0.0;
		maxForwardCrouchSpeed	= 3 + 0.0;
		maxSideCrouchSpeed		= 2 + 0.0;
		
		jumpForce			= 12 * 90;
		jumpEnergyDrain	= 0;
		jumpDelay			= 3;
		minJumpEnergy		= 0;
	};
}

if(!isObject(CRPG_Civilian_Mid_Armor))
{
	datablock PlayerData(CRPG_Civilian_Mid_Armor : CRPG_Civilian_Armor)
	{
		maxEnergy			= 80;
		rechargeRate		= 0.4;
		
		// Speed Properties
		runEnergyDrain		= 0;
		runForce				= 44 * 90;
		maxBackwardSpeed	= 4 - 1.5;
		maxForwardSpeed	= 7 - 3.0;
		maxSideSpeed		= 6 - 2.0;
		minRunEnergy		= 0;
		
		jumpForce			= 10 * 90;
		jumpEnergyDrain	= 0;
		jumpDelay			= 3;
		minJumpEnergy		= 0;
	};
}

if(!isObject(CRPG_Civilian_Low_Armor))
{
	datablock PlayerData(CRPG_Civilian_Low_Armor : CRPG_Civilian_Armor)
	{
		maxEnergy			= 60;
		rechargeRate		= 0.3;
		
		// Speed Properties
		runEnergyDrain		= 0;
		runForce				= 40 * 90;
		maxBackwardSpeed	= 4 - 2;
		maxForwardSpeed	= 7 - 3.5;
		maxSideSpeed		= 6 - 2.7;
		minRunEnergy		= 0;
		
		jumpForce			= 8 * 90;
		jumpEnergyDrain	= 0;
		jumpDelay			= 3;
		minJumpEnergy		= 0;
	};
}
