datablock AudioProfile(CRPG_GasMask_Exhale_Sound)
{
	filename		= $CRPG::Path::Sounds @ "gasmask_exhale.wav";
	description	= AudioClose3d;
	preload		= true;
};

datablock AudioProfile(CRPG_GasMask_Inhale_Sound)
{
	filename		= $CRPG::Path::Sounds @ "gasmask_inhale.wav";
	description	= AudioClose3d;
	preload		= true;
};

datablock ItemData(CRPG_GasMask_Item)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system
	
	 // Basic Item Properties
	shapeFile = $CRPG::Path::Shapes @ "GasMask_Item.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	
	//gui stuff
	uiName = "Gas Mask";
	iconName = $CRPG::Path::Images @ "itemIcons/Icon_GasMask";
	doColorShift = false;
	
	 // Dynamic properties defined by the scripts
	image = CRPG_GasMask_Image;
	canDrop = true;
	handsFree = true;
};

datablock ShapeBaseImageData(CRPG_GasMask_Image)
{
	shapeFile = $CRPG::Path::Shapes @ "GasMask.dts";
	item = CRPG_GasMask_Item;
	emap = true;
	firstPerson = false;
	mountPoint = $HeadSlot;
	offset = "0 0 0";
	eyeOffset = "0 0 10";
	
	stateName[0]						= "Ready";
	stateTimeoutValue[0]				= 1.50;
	stateTransitionOnTimeout[0]	= "Exhale";
	stateWaitForTimeout[0]			= true;
	
	stateName[1]						= "Inhale";
	stateSound[1]						= CRPG_GasMask_Inhale_Sound;
	stateTimeoutValue[1]				= 1.00;
	stateTransitionOnTimeout[1]	= "Exhale";
	stateWaitForTimeout[1]			= true;
	
	stateName[2]						= "Exhale";
	stateSound[2]						= CRPG_GasMask_Exhale_Sound;
	stateTimeoutValue[2]				= 5.00;
	stateTransitionOnTimeout[2]	= "Inhale";
	stateWaitForTimeout[1]			= true;
};

function CRPG_GasMask_Item::onPickup(%this, %item, %obj, %slot)
{
	%obj.mountImage(%this.image, $BackSlot);
	return parent::onPickup(%this, %item, %obj, %slot);
}

function CRPG_GasMask_Item::onUse(%this, %obj, %slot)
{
	%obj.unMountImage(0);
	%obj.playThread(0, root);
	%obj.playThread(1, root);
}