if(!$CRPG_Temp::WeaponsMade)
{
	eval("AddDamageType(\"CRPGShotgun\", '<bitmap:" @ $CRPG::Path::Images @ "CI/CI_Shotgun> %1', '%2 <bitmap:" @ $CRPG::Path::Images @ "CI/CI_Shotgun> %1', 0.25, 1);");
	eval("AddDamageType(\"CRPGShotgunHeadshot\", '<bitmap:" @ $CRPG::Path::Images @ "CI/CI_Shotgun><bitmap:" @ $CRPG::Path::Images @ "CI/CI_Headshot> %1', '%2 <bitmap:" @ $CRPG::Path::Images @ "CI/CI_Shotgun><bitmap:" @ $CRPG::Path::Images @ "CI/CI_Headshot> %1', 0.25, 1);");
}

// Sounds
datablock AudioProfile(CRPG_Shotgun_ArmSound)
{
	filename		= $CRPG::Path::Sounds @ "shotgun_arm.wav";
	description	= AudioClose3d;
	preload		= true;
};

datablock AudioProfile(CRPG_Shotgun_FireSound)
{
	filename		= $CRPG::Path::Sounds @ "shotgun_fire.wav";
	description	= AudioClose3d;
	preload		= true;
};

datablock AudioProfile(CRPG_Shotgun_HitSound)
{
	filename		= $CRPG::Path::Sounds @ "generic_hit.wav";
	description	= AudioClose3d;
	preload		= true;
};

datablock AudioProfile(CRPG_Shotgun_ReloadSound)
{
	filename		= $CRPG::Path::Sounds @ "shotgun_reload.wav";
	description	= AudioClose3d;
	preload		= true;
};

// Dot Emitter
datablock ParticleData(CRPG_Shotgun_Explosion_Dot_Particle)
{
	dragCoefficient		= 2;
	gravityCoefficient	= 0;
	inheritedVelFactor	= 0.2;
	constantAcceleration	= 0.0;
	lifetimeMS				= 1240;
	lifetimeVarianceMS	= 1230;
	textureName				= "base/data/particles/dot";
	spinSpeed				= 0.0;
	spinRandomMin			= 0.0;
	spinRandomMax			= 0.0;
	colors[0]				= "1 1 0.0 0.9";
	colors[1]				= "1 1 1.0 0.0";
	sizes[0]					= 0.1;
	sizes[1]					= 0.2;
	useInvAlpha				= false;
};

datablock ParticleEmitterData(CRPG_Shotgun_Explosion_Dot_Emitter)
{
	lifeTimeMS			= 100;
	ejectionPeriodMS	= 3;
	periodVarianceMS	= 0;
	ejectionVelocity	= 3;
	velocityVariance	= 3.0;
	ejectionOffset		= 1.0;
	thetaMin				= 0;
	thetaMax				= 180;
	phiReferenceVel	= 0;
	phiVariance			= 360;
	overrideAdvance	= false;
	particles			= "CRPG_Shotgun_Explosion_Dot_Particle";
};

// Explosion
datablock ExplosionData(CRPG_Shotgun_Explosion)
{
	soundProfile		= CRPG_Shotgun_HitSound;
	
	lifeTimeMS			= 150;
	
	particleEmitter	= CRPG_Explosion_Star_Emitter;
	particleDensity	= 5;
	particleRadius		= 0.2;
	
	emitter[0]			= CRPG_Explosion_Star_Emitter;
	emitter[1]			= CRPG_Shotgun_Explosion_Dot_Emitter;
	
	faceViewer			= true;
	explosionScale		= "1 1 1";
	
	shakeCamera			= false;
	camShakeFreq		= "10.0 11.0 10.0";
	camShakeAmp			= "1.0 1.0 1.0";
	camShakeDuration	= 0.5;
	camShakeRadius		= 10.0;
	
	lightStartRadius	= 1;
	lightEndRadius		= 0;
	lightStartColor	= "0.3 0.6 0.7";
	lightEndColor		= "0 0 0";

	impulseRadius		= 2;
	impulseForce		= 7500;
};

// Debris
datablock DebrisData(CRPG_Shotgun_Debris)
{
	shapeFile			= $CRPG::Path::Shapes @ "Shotgun_Eject.dts";
	lifetime				= 5.0;
	minSpinSpeed		= -400.0;
	maxSpinSpeed		= 200.0;
	elasticity			= 0.5;
	friction				= 0.2;
	numBounces			= 0;
	staticOnMaxBounce = true;
	snapOnMaxBounce 	= false;
	fade					= true;
	gravModifier		= 2;
};

// Projectile
datablock ProjectileData(CRPG_Shotgun_Projectile)
{
	projectileShapeName	= $CRPG::Path::Shapes @ "Shotgun_Eject.dts";
	
	directDamage			= 25;
	directDamageType		= $DamageType::CRPGShotgun;
	radiusDamageType		= $DamageType::CRPGShotgun;
	
	brickExplosionRadius	= 0;
	brickExplosionImpact	= true;
	brickExplosionForce		= 10;
	brickExplosionMaxVolume = 1;
	brickExplosionMaxVolumeFloating = 2;
	
	impactImpulse			= 1900;
	verticalImpulse		= 400;
	explosion				= CRPG_Shotgun_Explosion;
	
	muzzleVelocity			= 1;
	velInheritFactor		= 1;
	
	armingDelay				= 0;
	lifetime					= 1000;
	fadeDelay				= 800;
	bounceElasticity		= 0.5;
	bounceFriction			= 0.20;
	isBallistic				= false;
	gravityMod				= 0.1;
	
	hasLight					= false;
	lightRadius				= 3.0;
	lightColor				= "0 0 0.5";
};

// Item
datablock ItemData(CRPG_Shotgun_Item)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system
	
	// Basic Item Properties
	shapeFile = $CRPG::Path::Shapes @ "Shotgun_Item.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	
	//gui stuff
	uiName = "Shotgun";
	iconName = $CRPG::Path::Images @ "itemIcons/Icon_Shotgun";
	doColorShift = false;
	colorShiftColor = "0.4 0.2 0 1.000";
	
	image = CRPG_Shotgun_Image;
	canDrop = true;
	isFirearm = true;
};

// Image
datablock ShapeBaseImageData(CRPG_Shotgun_Image)
{
	// Raycast Properties
	raycastWeaponRange				= 62;
	raycastWeaponOptimalRange		= 16;
	raycastWeaponTargets				= $CRPG::ShootMasks;
	raycastWeaponPierceTargets		= 0;
	raycastDirectDamage				= 10;
	raycastDirectDamageType			= $DamageType::CRPGShotgun;
	raycastCritDirectDamageType	= $DamageType::CRPGShotgunHeadshot;
	raycastExplosionProjectile		= CRPG_Shotgun_Projectile;
	raycastExplosionSound			= CRPG_Shotgun_HitSound;
	raycastExplosionPlayerSound	= CRPG_Shotgun_HitSound;
	raycastExplosionBrickSound		= CRPG_Shotgun_HitSound;
	raycastSpreadAmt					= 0.0035;	
	raycastSpreadCount				= 6;
	raycastTracerProjectile			= 0;
	raycastFromMuzzle					= true;
	
	// CRPG Properties
	ammo			= "shotgun";
	ammoMagSize	= 3;
	ammoUI		= "Shells";
	backpack		= CRPG_Shotgun_Back_Image;
	gunTier		= 2;
	kickBack		= 40;
	sensitive	= false;
	
	
	item = CRPG_Shotgun_Item;
	
	// Basic Item properties
	shapeFile = $CRPG::Path::Shapes @ "Shotgun.dts";
	emap = true;

	// Specify mount point & offset for 3rd person, and eye offset
	// for first person rendering.
	mountPoint = 0;
	offset = "0 0 0";
	eyeOffset = 0; //"0.7 1.2 -0.5";
	rotation = eulerToMatrix( "0 0 0" );

	// When firing from a point offset from the eye, muzzle correction
	// will adjust the muzzle vector to point to the eye LOS point.
	// Since this weapon doesn't actually fire from the muzzle point,
	// we need to turn this off.  
	correctMuzzleVector = true;

	// Add the WeaponImage namespace as a parent, WeaponImage namespace
	// provides some hooks into the inventory system.
	className = "WeaponImage";

	// Projectile
	item						= CRPG_Shotgun_Item;
	projectile				= CRPG_Shotgun_Projectile;
	projectileType			= Projectile;
	
	casing					= CRPG_Shotgun_Debris;
	shellExitDir			= "1.0 -1.3 1.0";
	shellExitOffset		= "0 0 0";
	shellExitVariance		= 15.0;	
	shellVelocity			= 7.0;
	
	//melee particles shoot from eye node for consistancy
	melee = false;
	//raise your arm up or not
	armReady = true;

	doColorShift = true;
	colorShiftColor = "0.4 0.2 0 1.000";

	//casing = " ";

	// Images have a state system which controls how the animations
	// are run, which sounds are played, script callbacks, etc. This
	// state system is downloaded to the client so that clients can
	// predict state changes and animate accordingly.  The following
	// system supports basic ready->fire->reload transitions as
	// well as a no-ammo->dryfire idle state.

	// Initial start up state
	stateName[0]								= "Activate";
	stateTransitionOnTimeout[0]			= "PreAmmoCheck";
	
	stateName[1]								= "Ready";
	stateAllowImageChange[1]				= true;
	stateTransitionOnNoAmmo[1]				= "AmmoCheck";
	stateTransitionOnTriggerDown[1]		= "Fire";
	stateWaitForTimeout[1]					= false;

	stateName[2]								= "Fire";
	stateTransitionOnTimeout[2]			= "Smoke";
	stateSequence[2]							= "fire";
	stateTimeoutValue[2]						= 0.15;
	stateFire[2]								= true;
	stateAllowImageChange[2]				= false;
	stateScript[2]								= "onFire";
	stateWaitForTimeout[2]					= true;
	stateEmitter[2]							= CRPG_Flash_Emitter;
	stateEmitterTime[2]						= 0.05;
	stateEmitterNode[2]						= "muzzleNode";
	stateSound[2]								= CRPG_Shotgun_FireSound;
	
	stateName[3]								= "Smoke";
	stateEmitter[3]							= CRPG_Smoke_Emitter;
	stateEmitterTime[3]						= 0.50;
	stateEmitterNode[3]						= "muzzleNode";
	stateTimeoutValue[3]						= 0.35;
	stateTransitionOnTimeout[3]			= "Reload_3";
	stateWaitForTimeout[3]					= true;
	
	stateName[4]								= "PreReload";
	stateTransitionOnTimeout[4]			= "Reload";
	stateTimeoutValue[4]						= 0.2;
	stateWaitForTimeout[4]					= true;

	stateName[5]								= "Reload";
	stateWaitForTimeout[5]					= true;
	stateTransitionOnTimeout[5]			= "Reload_2";
	stateTimeoutValue[5]						= 0.2;
	
	stateName[6]								= "Reload_2";
	stateScript[6]								= "onReload";
	stateSequence[6]							= "reload";
	stateSound[6]								= CRPG_Shotgun_ReloadSound;
	stateTimeoutValue[6]						= 1.5;
	stateTransitionOnTimeout[6]			= "Reload_4";
	stateWaitForTimeout[6]					= true;
	
	stateName[7]								= "Reload_3";
	stateEjectShell[7]						= true;
	stateSequence[7]							= "cock";
	stateSound[7]								= CRPG_Shotgun_ArmSound;
	stateTimeoutValue[7]						= 0.35;
	stateTransitionOnTriggerUp[7]			= "AmmoCheck";
	stateWaitForTimeout[7]					= true;
	
	stateName[8]								= "PreAmmoCheck";
	stateAllowImageChange[8]				= true;
	stateScript[8]								= "onAmmoCheck";
	stateTimeoutValue[8]						= 0;
	stateTransitionOnTimeout[8]			= "AmmoCheck";
	stateWaitForTimeout[8]					= false;
	
	stateName[9]								= "AmmoCheck";
	stateTransitionOnAmmo[9]				= "Ready";
	stateTransitionOnNoAmmo[9]				= "PreReload";
	stateAllowImageChange[9]				= true;
	
	stateName[10]								= "Reload_4";
	stateSequence[10]							= "cock";
	stateSound[10]								= CRPG_Shotgun_ArmSound;
	stateTimeoutValue[10]					= 0.35;
	stateTransitionOnTimeout[10]			= "Ready";
	stateWaitForTimeout[10]					= true;
	
};

// Back Image
datablock ShapeBaseImageData(CRPG_Shotgun_Back_Image)
{
	// Basic Item properties
	shapeFile = $CRPG::Path::Shapes @ "Shotgun_Item.dts";
	emap = true;
	weaponBackpack = true;
	weaponImage = CRPG_Shotgun_Image;

	// Specify mount point & offset for 3rd person, and eye offset
	// for first person rendering.
	mountPoint = 7;
	offset = "-0.20 -0.225 1.00";
	eyeOffset = "0 0 10";
	rotation = eulerToMatrix("50 -90 90");
	
	// Initial start up state
	stateName[0] = "Ready";
};

// Raycast Scripts
function CRPG_Shotgun_Image::isRaycastCritical(%this, %obj, %slot, %col, %pos, %normal)
{
	return %this.isRaycastHeadshot(%obj, %slot, %col, %pos, %normal);
}

function CRPG_Shotgun_Image::onFire(%this, %obj, %slot)
{
	%obj.ammo[%this.ammo]--;
	%obj.fireTime[%this.ammo] = $sim::time;
	
	if(%obj.ammo[%this.ammo] < 1)
		%obj.setImageAmmo(%slot, false);
	
	return parent::onFire(%this, %obj, %slot);
}

function CRPG_Shotgun_Image::onMount(%this, %obj, %slot)
{
	%obj.playThread(2, "armReadyLeft");
	%obj.hideNode("lhand");
	%obj.hideNode("lhook");
	%obj.hideNode("rhand");
	%obj.hideNode("rhook");
	
	if(%obj.ammo[%this.ammo] !$= "")
		if(%obj.ammo[%this.ammo] < 1)
			%obj.setImageAmmo(%slot, 0);
		else
			%obj.setImageAmmo(%slot, 1);
	else
		%obj.ammo[%this.ammo] = %this.ammoMagSize;
}

function CRPG_Shotgun_Image::onUnMount(%this, %obj, %slot)
{
	%obj.playThread(2, "root");
	
	if(isObject(%obj.client))
		applyCharacterPrefs(%obj.client);
	else
		applyDefaultCharacterPrefs(%obj);
}